#include <CrashTick.h>

#include <dos/dos.h>
#include <clib/dos_protos.h>

extern struct Config config;

void WriteDoLater(uchar *line)
{
   BPTR fh;

   if(!(fh=Open("PROGDIR:CrashTick.dolaterdata",MODE_READWRITE)))
      return;
      
   Seek(fh,0,OFFSET_END);
   FPrintf(fh,"%s\n",line);
   Close(fh);
}

int IsCTTemp(uchar *file)
{
   if(strnicmp(file,"CT_Temp.",8)==0)
      return(TRUE);

   return(FALSE);
}

short rawPackFile(uchar *file,struct ConfigNode *cnode);
short rawAddFlow(uchar *flow,uchar *line);

void DoLater(void)
{
   struct jbList FileList;
   struct FileEntry *fe;
   uchar oldname[200],newname[200],filename[200],flowname[200];
   struct ConfigNode *cnode;
   BPTR fh,newfh;
   uchar buf[400],cmd[20],node[20];
   struct Node4D n4d;

   if(jbReadDir(config.cfg_Tickdir,&FileList,IsCTTemp))
   {
      for(fe=(struct FileEntry *)FileList.First;fe;fe=fe->Next)
      {
         LogWrite(1,TICKERR,getString(TXT_FOUND_OLD_RENAMED),fe->Name);

         strcpy(oldname,config.cfg_Tickdir);
         AddPart(oldname,fe->Name,200);

         strcpy(newname,config.cfg_Tickdir);
         AddPart(newname,&fe->Name[8],200);

         Rename(oldname,newname);
      }

      jbFreeList(&FileList,sizeof(struct FileEntry));
   }

   if(!(fh=Open("PROGDIR:CrashTick.dolaterdata",MODE_OLDFILE)))
      return;

   LogWrite(2,TICKINFO,getString(TXT_FOUND_DOLATER));

   newfh=NULL;

   while(FGets(fh,buf,400) && buf[0]!=0)
   {
      if(buf[strlen(buf)-1]==10)
         buf[strlen(buf)-1]=0;

      jbcpos=0;

      if(jbstrcpy(cmd,buf,20))
      {
         if(stricmp(cmd,"Packdelete")==0)
         {
            jbstrcpy(filename,buf,200);
            jbstrcpy(node,buf,20);

            if(Parse4D(node,&n4d))
            {
               for(cnode=(struct ConfigNode *)config.CNodeList.First;cnode;cnode=cnode->Next)
                  if(Compare4D(&cnode->Node,&n4d)==0) break;

               if(cnode)
               {
                  if(rawPackFile(filename,cnode))
                  {
                     DeleteFile(filename);
                  }
                  else
                  {
                     if(!newfh) newfh=Open("PROGDIR:CrashTick.dolaterdata.new",MODE_NEWFILE);
                     if(newfh) FPrintf(newfh,"%s\n",buf);
                  }
               }
            }
         }
         else if(stricmp(cmd,"Pack")==0)
         {
            jbstrcpy(filename,buf,200);
            jbstrcpy(node,buf,20);

            if(Parse4D(node,&n4d))
            {
               for(cnode=(struct ConfigNode *)config.CNodeList.First;cnode;cnode=cnode->Next)
                  if(Compare4D(&cnode->Node,&n4d)==0) break;

               if(cnode)
               {
                  if(!rawPackFile(filename,cnode))
                  {
                     if(!newfh) newfh=Open("PROGDIR:CrashTick.dolaterdata.new",MODE_NEWFILE);
                     if(newfh) FPrintf(newfh,"%s\n",buf);
                  }
               }
            }
         }
         else if(stricmp(cmd,"Addflow")==0)
         {
            jbstrcpy(flowname,buf,200);
            jbstrcpy(filename,buf,200);

            if(!rawAddFlow(flowname,filename))
            {
               if(!newfh) newfh=Open("PROGDIR:CrashTick.dolaterdata.new",MODE_NEWFILE);
               if(newfh) FPrintf(newfh,"%s\n",buf);
            }
         }
         else
         {
            LogWrite(1,TICKERR,getString(ERR_UNKNOWN_DOLATER),cmd);
            if(!newfh) newfh=Open("PROGDIR:CrashTick.dolaterdata.new",MODE_NEWFILE);
            if(newfh) FPrintf(newfh,"%s\n",buf);
         }
      }
   }

   Close(fh);
   DeleteFile("PROGDIR:CrashTick.dolaterdata");

   if(newfh)
   {
      Close(newfh);
      Rename("PROGDIR:CrashTick.dolaterdata.new","PROGDIR:CrashTick.dolaterdata");
   }
}
