#include <CrashTick.h>
#include <exec/types.h>
extern struct Config config;

ULONG matchnum(UBYTE *s1,UBYTE *s2)
{
   ULONG c,res;

   res=0;
   c=0;

   while(s1[c] && s2[c] && s1[c]==s2[c])
   {
      res++;
      c++;
   }

   return(res);
}

struct Aka *BestAka(struct Node4D *n4d)
{
   UBYTE nodebuf[50];
   UBYTE akabuf[50];
   LONG bestnum;
   struct Aka *aka,*bestmatch;

   sprintf(nodebuf,"%lu:%lu/%lu.%lu",
      n4d->Zone,
      n4d->Net,
      n4d->Node,
      n4d->Point);

   bestnum=0;
   bestmatch=(struct Aka *)config.AkaList.First;

   for(aka=(struct Aka *)config.AkaList.First;aka;aka=aka->Next)
   {
      sprintf(akabuf,"%lu:%lu/%lu.%lu",
         aka->Node.Zone,
         aka->Node.Net,
         aka->Node.Node,
         aka->Node.Point);

      if(matchnum(nodebuf,akabuf) > bestnum)
      {
         bestnum=matchnum(nodebuf,akabuf);
         bestmatch=aka;
      }
   }

   return(bestmatch);
}

int IsTick(uchar *file)
{
   if(strlen(file)!=12)             return(FALSE);
   if(file[8]!='.')                 return(FALSE);
   if(stricmp(&file[9],"tic")!=0)   return(FALSE);

   return(TRUE);
}

int IsZick(uchar *file)
{
   if(strlen(file)!=12)             return(FALSE);
   if(file[8]!='.')                 return(FALSE);
   if(stricmp(&file[9],"zic")!=0)   return(FALSE);

   return(TRUE);
}

int IsLick(uchar *file)
{
   if(strlen(file)!=12)             return(FALSE);
   if(file[8]!='.')                 return(FALSE);
   if(stricmp(&file[9],"lic")!=0)   return(FALSE);

   return(TRUE);
}

void ExpandPacker(UBYTE *dest,ULONG destsize,UBYTE *cmd,UBYTE *arc,UBYTE *file)
{
   ULONG c,d;

   d=0;
   for(c=0;c<strlen(cmd) && d!=destsize-1;c++)
   {
      if(cmd[c]=='%' && (cmd[c+1]|32)=='a')
      {
         strncpy(&dest[d],arc,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='f')
      {
         strncpy(&dest[d],file,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else dest[d++]=cmd[c];
   }
   dest[d]=0;
}

void MakeCommand(uchar *dest,ulong destsize,uchar *cmd,
   uchar *areaname,
   uchar *filename,
   uchar *path,
   uchar *fullfile,
   uchar *desc,
   uchar *fromnode,
   uchar *magic,
   uchar *origin,
   uchar *size,
   uchar *userdata)
{
   ULONG c,d;

   d=0;
   for(c=0;c<strlen(cmd) && d!=destsize-1;c++)
   {
      if(cmd[c]=='\\' && (cmd[c+1]|32)=='n')
      {
         strncpy(&dest[d],"\n",destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='b')
      {
         strncpy(&dest[d],size,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='o')
      {
         strncpy(&dest[d],origin,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='m')
      {
         strncpy(&dest[d],magic,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='f')
      {
         strncpy(&dest[d],fromnode,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='d')
      {
         strncpy(&dest[d],desc,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='s')
      {
         strncpy(&dest[d],fullfile,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='p')
      {
         strncpy(&dest[d],path,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='n')
      {
         strncpy(&dest[d],filename,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='u')
      {
         strncpy(&dest[d],userdata,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && (cmd[c+1]|32)=='a')
      {
         strncpy(&dest[d],areaname,destsize-1-d);
         dest[destsize-1]=0;
         d=strlen(dest);
         c++;
      }
      else if(cmd[c]=='%' && cmd[c+1]!=0)
      {
         c++;
         dest[d++]=cmd[c];
      }
      else dest[d++]=cmd[c];
   }
   dest[d]=0;
}

BOOL CheckFlags(UBYTE group,UBYTE *node)
{
   UBYTE c;

   for(c=0;c<strlen(node);c++)
   {
      if(group==node[c])
         return(TRUE);
    }

   return(FALSE);
}
