#include <CrashTickPrefs.h>

struct NewMenu akanewmenus[] = { {NM_TITLE,"",NULL,0,0,NULL},                     /* >Edit        */
                                 {NM_ITEM, "",NULL,0,0,NULL},                     /* Duplicate... */
                                 {NM_END,  "",NULL,0,0,NULL}};

struct Hook AkaHelpHook = { {NULL}, HelpHookEntry,NULL,(APTR)HELP_AKAS};

struct List Aka_TempList;
struct TempNode *Aka_CurrentNode;

int CheckDupeAka(struct Node4D *node,struct Aka *currentaka)
{
   struct Aka *aka;
   
   for(aka=(struct Aka *)config.AkaList.First;aka;aka=aka->Next)
      if(Compare4D(node,&aka->Node)==0 && aka!=currentaka) return(FALSE);

   return(TRUE);
}

void Aka_UpdateList(void)
{
   struct TempNode *tempnode;
   struct Aka *aka;
   ulong num;

   LV_DetachList(parthandle,4000);
   FreeTempNodes(&Aka_TempList);
   NewList(&Aka_TempList);

   num=0;

   for(aka=(struct Aka *)config.AkaList.First;aka;aka=aka->Next)
   {
      if(tempnode=AllocCleared(sizeof(struct TempNode)))
      {
         PrintFull4D(&aka->Node,tempnode->buf);
         tempnode->Node.ln_Name=tempnode->buf;
         tempnode->UserData=aka;
         tempnode->num=num;

         num++;

         AddTail(&Aka_TempList,(struct Node *)tempnode);
      }
   }

   LV_AttachList(parthandle,4000,&Aka_TempList);
}

void Aka_ChangedNum(void)
{
   LV_ChangedNum(parthandle,4000,&Aka_TempList);

   if(!Aka_TempList.lh_Head->ln_Succ)
   {
      OffMenu(partwin,FULLMENUNUM(0,0,0));
   }
   else
   {
      OnMenu(partwin,FULLMENUNUM(0,0,0));
   }
}

void Aka_SetCurrent(ulong num)
{
   ulong c;

   if(!Aka_TempList.lh_Head->ln_Succ)
   {
      LV_SetCurrent(parthandle,4000,&Aka_TempList,NULL);
      Aka_CurrentNode=NULL;
      return;
   }

   Aka_CurrentNode=(struct TempNode *)Aka_TempList.lh_Head;

   for(c=0;c<num;c++)
      Aka_CurrentNode=(struct TempNode *)Aka_CurrentNode->Node.ln_Succ;

   LV_SetCurrent(parthandle,4000,&Aka_TempList,Aka_CurrentNode);
}

void Aka_UpdateConfig(void)
{
   return;
}

void Aka_Add(void)
{
   BOOL res;
   struct Aka *aka;
   UBYTE buf[80];
   struct TempNode *tn;
   short kg;
   struct Node4D n4d;

   buf[0]=0;

   kg=TRUE;

   while(kg)
   {
      res=rtGetString(buf,79,getString(PREFS_LIST_ADD),NULL,
               RTGS_TextFmt,getString(PREFS_AKA_ADD),
               RTGS_Flags, GSREQF_CENTERTEXT,
               RT_Window,  partwin,
               RT_WaitPointer, TRUE,
               RT_LockWindow, TRUE,
               RT_Underscore,'_',
               TAG_END);

      if(!res)
         return;

      if(Parse4D(buf,&n4d))
      {
         if(CheckDupeAka(&n4d,NULL))
         {
            kg=FALSE;
         }
         else
         {
            RequestError(partwin,getString(PREFS_AKA_ALREADY_HAS),
               n4d.Zone,
               n4d.Net,
               n4d.Node,
               n4d.Point);
         }
      }
      else
      {
         RequestError(partwin,getString(CFG_ERR_INVALID_NODE),buf);
      }
   }

   if(!(aka=AllocCleared(sizeof(struct Aka))))
   {
      DisplayBeep(NULL);
      return;
   }

   Copy4D(&aka->Node,&n4d);
   jbAddNode(&config.AkaList,(struct jbNode *)aka);
   Aka_UpdateList();

   tn=(struct TempNode *)Aka_TempList.lh_TailPred;

   Aka_ChangedNum();
   Aka_SetCurrent(tn->num);
   config.configchanged=TRUE;
}

void Aka_Duplicate(void)
{
   BOOL res;
   struct Aka *aka,*oldaka;
   UBYTE buf[80];
   struct TempNode *tn;
   int kg;
   struct Node4D n4d;
   
   oldaka=(struct Aka *)Aka_CurrentNode->UserData;

   PrintFull4D(&oldaka->Node,buf);

   kg=TRUE;

   while(kg)
   {
      res=rtGetString(buf,79,getString(PREFS_LIST_ADD),NULL,
               RTGS_TextFmt,getString(PREFS_AKA_ADD),
               RTGS_Flags, GSREQF_CENTERTEXT,
               RT_Window,  partwin,
               RT_WaitPointer, TRUE,
               RT_LockWindow, TRUE,
               RT_Underscore,'_',
               TAG_END);

      if(!res)
         return;

      if(Parse4D(buf,&n4d))
      {
         if(CheckDupeAka(&n4d,NULL))
         {
            kg=FALSE;
         }
         else
         {
            RequestError(partwin,getString(PREFS_AKA_ALREADY_HAS),
               n4d.Zone,
               n4d.Net,
               n4d.Node,
               n4d.Point);
         }
      }
      else
      {
         RequestError(partwin,getString(CFG_ERR_INVALID_NODE),buf);
      }
   }

   if(!(aka=AllocCleared(sizeof(struct Aka))))
   {
      DisplayBeep(NULL);
      return;
   }

   Copy4D(&aka->Node,&n4d);
   jbAddNode(&config.AkaList,(struct jbNode *)aka);
   Aka_UpdateList();

   tn=(struct TempNode *)Aka_TempList.lh_TailPred;

   Aka_ChangedNum();
   Aka_SetCurrent(tn->num);
   config.configchanged=TRUE;
}

void Aka_Remove(void)
{
   struct Aka *aka;
   UBYTE buf[200];
   BOOL res;
   ULONG tmp;
   long announces,areas,akas;
   struct Area *area,*area2;
   struct Announce *announce,*announce2;
   int kg;
   struct List tmpakalist;
   ulong c;
   struct TempNode *tempnode;
   struct Aka *tmpaka,*newaka;

   areas=0;
   announces=0;
   akas=0;

   aka=(struct Aka *)Aka_CurrentNode->UserData;

   for(announce=(struct Announce *)config.AnnounceList.First;announce;announce=announce->Next)
      if(announce->Aka == aka) announces++;

   for(area=(struct Area *)config.AreaList.First;area;area=area->Next)
      if(area->Aka == aka) areas++;

   for(aka=(struct Aka *)config.AkaList.First;aka;aka=aka->Next)
      akas++;

   aka=(struct Aka *)Aka_CurrentNode->UserData;

   sprintf(buf,getString(PREFS_AKA_REM),
      aka->Node.Zone,
      aka->Node.Net,
      aka->Node.Node,
      aka->Node.Point);

   res=rtEZRequestTags(buf,getString(PREFS_TXT_REMOVE_CANCEL),NULL,NULL,
      RT_Underscore,'_',
      RT_Window,partwin,
      RT_WaitPointer,TRUE,
      RT_LockWindow, TRUE,
      RTEZ_Flags, EZREQF_CENTERTEXT | EZREQF_NORETURNKEY,
      TAG_END);

   if(!res)
      return;

   if(areas || announces)
   {
      sprintf(buf,getString(PREFS_AKA_REM_USED),
         aka->Node.Zone,
         aka->Node.Net,
         aka->Node.Node,
         aka->Node.Point,
         areas,
         announces);

      kg=TRUE;

      while(kg)
      {
         res=rtEZRequestTags(buf,getString(PREFS_AKA_REM_USEDGADS),NULL,NULL,
            RT_Underscore,'_',
            RT_Window,partwin,
            RT_WaitPointer,TRUE,
            RT_LockWindow, TRUE,
            RTEZ_Flags, EZREQF_CENTERTEXT | EZREQF_NORETURNKEY,
            TAG_END);

         if(!res)
            return;

         if(res == 1)
         {
            /* remove */

            area=(struct Area *)config.AreaList.First;

            while(area)
            {
               area2=area->Next;

               if(area->Aka == aka)
               {
                  jbFreeList(&area->TickNodes,sizeof(struct TickNode));
                  jbFreeNode(&config.AreaList,(struct jbNode *)area,sizeof(struct Area));
               }

               area=area2;
            }

            announce=(struct Announce *)config.AnnounceList.First;

            while(announce)
            {
               announce2=announce->Next;

               if(announce->Aka == aka)
               {
                  jbFreeNode(&config.AnnounceList,(struct jbNode *)announce,sizeof(struct Announce));
               }

               announce=announce2;
            }

            kg=FALSE;
         }
         else if(res == 2)
         {
            if(akas == 1)
            {
               RequestError(partwin,getString(PREFS_AKA_REM_NOOTHER));
            }
            else
            {
               NewList(&tmpakalist);

               for(tmpaka=(struct Aka *)config.AkaList.First;tmpaka;tmpaka=tmpaka->Next)
               {
                  if(aka!=tmpaka)
                  {
                     if(!(tempnode=(struct TempNode *)AllocCleared(sizeof(struct TempNode))))
                     {
                        DisplayBeep(NULL);
                        FreeTempNodes(&tmpakalist);
                        return;
                     }

                     PrintFull4D(&tmpaka->Node,tempnode->buf);
                     tempnode->Node.ln_Name=tempnode->buf;
                     tempnode->UserData=tmpaka;
                     AddTail(&tmpakalist,(struct Node *)tempnode);
                  }
               }

               res=AskList(&tmpakalist,getString(PREFS_ASKLIST_SELECT_AKA),partwin);

               if(res==-1)
               {
                  FreeTempNodes(&tmpakalist);
               }
               else
               {
                  tempnode=(struct TempNode *)tmpakalist.lh_Head;

                  for(c=0;c<res;c++) 
                     tempnode=(struct TempNode *)tempnode->Node.ln_Succ;
                     
                  newaka=tempnode->UserData;

                  FreeTempNodes(&tmpakalist);

                  for(area=(struct Area *)config.AreaList.First;area;area=area->Next)
                     if(area->Aka == aka) area->Aka=newaka;

                  for(announce=(struct Announce *)config.AnnounceList.First;announce;announce=announce->Next)
                     if(announce->Aka == aka) announce->Aka=newaka;

                  kg=FALSE;
               }
            }
         }
      }
   }

   tmp=Aka_CurrentNode->num;

   if(!Aka_CurrentNode->Node.ln_Succ->ln_Succ)
      tmp--;

   jbFreeNode(&config.AkaList,(struct jbNode *)Aka_CurrentNode->UserData,sizeof(struct Aka));

   Aka_UpdateList();
   Aka_ChangedNum();
   Aka_SetCurrent(tmp);

   config.configchanged=TRUE;
}

void PartAka(void)
{
   struct IntuiMessage *IntuiMessage;
   APTR iaddress;
   ULONG class,code,qualifier;
   struct Menu *akamenus;
   struct MenuItem *menuitem;
   ulong num;
   struct Node4D n4d;
   struct Aka *aka;

   NewList(&Aka_TempList);

   parthandle = LT_CreateHandleTags(scr,LH_EditHook,     &StrEditHook,
                                        LH_RawKeyFilter, FALSE,
                                        LH_LocaleHook,   &LocaleHook,
                                        TAG_DONE);

   if(!parthandle)
      return;

   akanewmenus[0].nm_Label   = getString(PREFS_EDITMENU_EDIT);

   akanewmenus[1].nm_CommKey = getString(PREFS_EDITMENU_DUP);
   akanewmenus[1].nm_Label   = getString(PREFS_EDITMENU_DUP)+2;

   akamenus=LT_LayoutMenus(parthandle,akanewmenus,
         GTMN_FrontPen,        0L,
         GTMN_TextAttr,        scr->Font,
         GTMN_NewLookMenus,    TRUE,
         LH_MenuGlyphs,        TRUE,
         TAG_DONE);

	if(!akamenus)
   {
      DisplayBeep(NULL);
      LT_DeleteHandle(parthandle);
      return;
   }

   LT_New(parthandle,
      LA_Type, HORIZONTAL_KIND,
      LA_LabelID, PREFS_AKA_AKA,
      TAG_DONE);

      LT_New(parthandle,
         LA_Type,      VERTICAL_KIND,
         TAG_DONE);

         LV_CreateListView(parthandle,10,4000);

      LT_EndGroup(parthandle);

   LT_EndGroup(parthandle);

   partwin=LT_Build(parthandle,LAWN_IDCMP,    IDCMP_CLOSEWINDOW|IDCMP_RAWKEY,
                               LAWN_Parent,   mainwin,
                               LAWN_HelpHook, &AkaHelpHook,
                               LAWN_Title,    getString(PREFS_BUTTON_AKAS),
                               WA_Flags,      WFLG_ACTIVATE|WFLG_CLOSEGADGET|WFLG_DEPTHGADGET|WFLG_DRAGBAR|WFLG_NEWLOOKMENUS,
                               LAWN_Menu,     akamenus,
                               TAG_END);

   if(!partwin)
   {
      LT_DeleteHandle(parthandle);
	   FreeMenus(akamenus);
      DisplayBeep(NULL);
      return;
   }

   Aka_UpdateList();
   Aka_SetCurrent(0);
   Aka_ChangedNum();

   for(;;)
   {
      while(IntuiMessage=(struct IntuiMessage *)LT_GetIMsg(parthandle))
      {
         class=IntuiMessage->Class;
         code=IntuiMessage->Code;
         iaddress=IntuiMessage->IAddress;
         qualifier=IntuiMessage->Qualifier;

         LT_ReplyIMsg(IntuiMessage);

         switch(class)
         {
            case IDCMP_RAWKEY:         if(code == RAWKEY_TAB) LT_Activate(parthandle,4000+LV_STRING);
                                       break;

            case IDCMP_GADGETUP:       /* No current node necessary */

                                       switch(((struct Gadget *)iaddress)->GadgetID)
                                       {
                                          case 4000+LV_ADD:
                                             Aka_UpdateConfig();
                                             Aka_Add();
                                             break;
                                       }

                                       /* Current node necessary */

                                       if(Aka_CurrentNode)
                                       {
                                          aka=Aka_CurrentNode->UserData;

                                          switch(((struct Gadget *)iaddress)->GadgetID)
                                          {
                                             case 4000+LV_LIST:
                                                Aka_UpdateConfig();
                                                Aka_SetCurrent(code);
                                                break;

                                             case 4000+LV_STRING:
                                                if(!Parse4D(getgadgetstring((struct Gadget *)iaddress),&n4d))
                                                {
                                                   DisplayBeep(NULL);
                                                   LT_Activate(parthandle,4000+LV_STRING);
                                                }
                                                else
                                                {
                                                   if(CheckDupeAka(&n4d,aka))
                                                   {
                                                      LV_DetachList(parthandle,4000);
                                                      PrintFull4D(&n4d,Aka_CurrentNode->buf);
                                                      Copy4D(&aka->Node,&n4d);
                                                      LV_AttachList(parthandle,4000,&Aka_TempList);
                                                      config.configchanged=TRUE;
                                                   }
                                                   else
                                                   {
                                                      RequestError(partwin,getString(PREFS_AKA_ALREADY_HAS),
                                                         n4d.Zone,
                                                         n4d.Net,
                                                         n4d.Node,
                                                         n4d.Point);

                                                      LT_Activate(parthandle,4000+LV_STRING);
                                                   }
                                                }
                                                break;

                                             case 4000+LV_REMOVE:
                                                Aka_Remove();
                                                break;

                                             case 4000+LV_UP:
                                                LV_MoveUp(parthandle,4000,&Aka_TempList,Aka_CurrentNode,&config.AkaList);
                                                config.configchanged=TRUE;
                                                break;

                                             case 4000+LV_DOWN:
                                                LV_MoveDown(parthandle,4000,&Aka_TempList,Aka_CurrentNode,&config.AkaList);
                                                config.configchanged=TRUE;
                                                break;
                                          }
                                      }
                                      break;

            case IDCMP_MENUPICK:      num=code;
                                      while(num!=MENUNULL)
                                      {
                                          if(Aka_CurrentNode)
                                          {
                                             if(MENUNUM(num)==0 && ITEMNUM(num)==0)
                                             {
                                                Aka_UpdateConfig();
                                                Aka_Duplicate();
                                             }

                                             menuitem=ItemAddress(akamenus,num);
                                             num=menuitem->NextSelect;
                                          }
                                       }
                                      break;


            case IDCMP_CLOSEWINDOW:   Aka_UpdateConfig();
                                      ClearMenuStrip(parthandle->Window);
                                      LT_DeleteHandle(parthandle);
                                      FreeMenus(akamenus);
                                      parthandle=NULL;

                                      FreeTempNodes(&Aka_TempList);
                                      return;

         }
      }
      WaitPort(partwin->UserPort);
   }
}

