#include <CrashTickPrefs.h>

struct Hook CommandsHelpHook = { {NULL}, HelpHookEntry,NULL,(APTR)HELP_COMMANDS};

void PartCommands(void)
{
   struct IntuiMessage *IntuiMessage;
   APTR iaddress;
   ULONG class,code,qualifier;

   strcpy(config2.cfg_ImportCommand,config.cfg_ImportCommand);
   strcpy(config2.cfg_MagicCommand,config.cfg_MagicCommand);
   strcpy(config2.cfg_ReplaceCommand,config.cfg_ReplaceCommand);
   strcpy(config2.cfg_ZipAdd,config.cfg_ZipAdd);
   strcpy(config2.cfg_ZipExtract,config.cfg_ZipExtract);
   strcpy(config2.cfg_LhaAdd,config.cfg_LhaAdd);
   strcpy(config2.cfg_LhaExtract,config.cfg_LhaExtract);

   parthandle = LT_CreateHandleTags(scr,LH_EditHook,     &StrEditHookNext, 
                                        LH_RawKeyFilter, FALSE,
                                        LH_LocaleHook,   &LocaleHook,
                                        TAG_DONE);

   if(!parthandle)
      return;

   LT_New(parthandle,
      LA_Type, VERTICAL_KIND,
      TAG_DONE);

      LT_New(parthandle,
         LA_Type,      VERTICAL_KIND,
         LA_LabelID,   PREFS_COMMANDS_IMPORTCMDS,
         TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_COMMANDS_IMPORT,
            LA_Chars,     40,
            GTST_MaxChars,199,
            LA_STRPTR,    config2.cfg_ImportCommand,
            LA_ID,        1,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_COMMANDS_MAGIC,
            LA_Chars,     40,
            GTST_MaxChars,199,
            LA_STRPTR,    config2.cfg_MagicCommand,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_COMMANDS_REPLACE,
            LA_Chars,     40,
            GTST_MaxChars,199,
            LA_STRPTR,    config2.cfg_ReplaceCommand,
            TAG_DONE);

      LT_EndGroup(parthandle);

      LT_New(parthandle,
         LA_Type,      VERTICAL_KIND,
         LA_LabelID,   PREFS_COMMANDS_PACKERCMDS,
         TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_COMMANDS_ZIPEXT,
            LA_Chars,     40,
            GTST_MaxChars,79,
            LA_STRPTR,    config2.cfg_ZipExtract,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_COMMANDS_ZIPADD,
            LA_Chars,     40,
            GTST_MaxChars,79,
            LA_STRPTR,    config2.cfg_ZipAdd,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_COMMANDS_LHAEXT,
            LA_Chars,     40,
            GTST_MaxChars,79,
            LA_STRPTR,    config2.cfg_LhaExtract,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_COMMANDS_LHAADD,
            LA_Chars,     40,
            GTST_MaxChars,79,
            LA_STRPTR,    config2.cfg_LhaAdd,
            TAG_DONE);

      LT_EndGroup(parthandle);

   LT_EndGroup(parthandle);

   partwin=LT_Build(parthandle,LAWN_IDCMP,    IDCMP_CLOSEWINDOW|IDCMP_RAWKEY,
                               LAWN_Parent,   mainwin,
                               LAWN_HelpHook, &CommandsHelpHook,
                               LAWN_Title,    getString(PREFS_BUTTON_COMMANDS),
                               WA_Flags,      WFLG_ACTIVATE|WFLG_CLOSEGADGET|WFLG_DEPTHGADGET|WFLG_DRAGBAR|WFLG_NEWLOOKMENUS,
                               TAG_END);

   if(!partwin)
   {
      LT_DeleteHandle(parthandle);
      DisplayBeep(NULL);
      return;
   }

   for(;;)
   {
      while(IntuiMessage=(struct IntuiMessage *)LT_GetIMsg(parthandle))
      {
         class=IntuiMessage->Class;
         code=IntuiMessage->Code;
         iaddress=IntuiMessage->IAddress;
         qualifier=IntuiMessage->Qualifier;

         LT_ReplyIMsg(IntuiMessage);

         switch(class)
         {
            case IDCMP_RAWKEY:        if(code == RAWKEY_TAB) LT_Activate(parthandle,1);
                                      break;

            case IDCMP_CLOSEWINDOW:   LT_DeleteHandle(parthandle);
                                      parthandle=NULL;

                                      strcmpcpy(config.cfg_ImportCommand,config2.cfg_ImportCommand);
                                      strcmpcpy(config.cfg_MagicCommand,config2.cfg_MagicCommand);
                                      strcmpcpy(config.cfg_ReplaceCommand,config2.cfg_ReplaceCommand);
                                      strcmpcpy(config.cfg_ZipAdd,config2.cfg_ZipAdd);
                                      strcmpcpy(config.cfg_ZipExtract,config2.cfg_ZipExtract);
                                      strcmpcpy(config.cfg_LhaAdd,config2.cfg_LhaAdd);
                                      strcmpcpy(config.cfg_LhaExtract,config2.cfg_LhaExtract);

                                      return;
         }
      }
      WaitPort(partwin->UserPort);
   }
}
