#include <CrashTickPrefs.h>

UBYTE *loglevels[6];

struct Hook GeneralHelpHook = { {NULL}, HelpHookEntry,NULL,(APTR)HELP_GENERAL};

__saveds LONG logdispfunc(struct Gadget *gad,WORD num)
{
   return((LONG)loglevels[num-1]);
}

void PartGeneral(void)
{
   struct IntuiMessage *IntuiMessage;
   APTR iaddress;
   ULONG class,code,qualifier,gid;
   struct Node4D n4d;
   UBYTE nodebuf[40];

   loglevels[0]=getString(PREFS_LOGLEVELS_MINIMUM);
   loglevels[1]=getString(PREFS_LOGLEVELS_SMALL);
   loglevels[2]=getString(PREFS_LOGLEVELS_SPARSE);
   loglevels[3]=getString(PREFS_LOGLEVELS_NORMAL);
   loglevels[4]=getString(PREFS_LOGLEVELS_EXTRA);
   loglevels[5]=getString(PREFS_LOGLEVELS_DEBUG);

   strcpy(config2.cfg_Sysop,config.cfg_Sysop);
   Copy4D(&config2.cfg_Fake4D,&config.cfg_Fake4D);
   strcpy(config2.cfg_FakePW,config.cfg_FakePW);
   strcpy(config2.cfg_Logfile,config.cfg_Logfile);
   config2.cfg_Loglevel=config.cfg_Loglevel;
   config2.cfg_LogBufferLines=config.cfg_LogBufferLines;
   config2.cfg_LogBufferSecs=config.cfg_LogBufferSecs;
   config2.cfg_MaxWaitPickup=config.cfg_MaxWaitPickup;
   config2.cfg_RaidMaxLines=config.cfg_RaidMaxLines;

   PrintFull4D(&config2.cfg_Fake4D,nodebuf);

   parthandle = LT_CreateHandleTags(scr,LH_EditHook,     &StrEditHookNext,
                                        LH_RawKeyFilter, FALSE,
                                        LH_LocaleHook,   &LocaleHook,
                                        TAG_DONE);

   if(!parthandle)
      return;

   LT_New(parthandle,
      LA_Type, VERTICAL_KIND,
      TAG_DONE);

      LT_New(parthandle,
         LA_Type,      VERTICAL_KIND,
         LA_LabelID,   PREFS_GENERAL_MISC,
         TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_GENERAL_SYSOP,
            LA_Chars,     35,
            GTST_MaxChars,35,
            LA_STRPTR,    config2.cfg_Sysop,
            LA_ID,        1,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      INTEGER_KIND,
            LA_LabelID,   PREFS_GENERAL_MAXWAIT,
            GTIN_EditHook,&StrEditHookNext,
            LA_ULONG,     &config2.cfg_MaxWaitPickup,
            LA_ID,        2,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      INTEGER_KIND,
            LA_LabelID,   PREFS_GENERAL_MAXRAID,
            GTIN_EditHook,&StrEditHookNext,
            LA_ULONG,     &config2.cfg_RaidMaxLines,
            LA_ID,        9,
            TAG_DONE);

      LT_EndGroup(parthandle);

      LT_New(parthandle,
         LA_Type,      VERTICAL_KIND,
         LA_LabelID,   PREFS_GENERAL_LOG,
         TAG_DONE);

         LT_New(parthandle,
            LA_Type,      VERTICAL_KIND,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_GENERAL_LOGFILE,
            LA_Chars,     35,
            LA_ID,        3,
            LAST_Picker,  TRUE,
            LA_STRPTR,    config2.cfg_Logfile,
            GTST_MaxChars,39,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      SLIDER_KIND,
            LA_ID,        4,
            LA_LabelID,   PREFS_GENERAL_LOGLEVEL,
            LA_Chars,     20,
            GTSL_DispFunc,logdispfunc,
            GTSL_LevelFormat,"%s   ",
            LASL_FullCheck,TRUE,
            GTSL_Max,6,
            GTSL_Min,1,
            PGA_Freedom,   LORIENT_HORIZ,
            LA_UWORD,      &config2.cfg_Loglevel,
            TAG_DONE);

         LT_EndGroup(parthandle);

         LT_New(parthandle,
            LA_Type,      HORIZONTAL_KIND,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      INTEGER_KIND,
            LA_LabelID,   PREFS_GENERAL_LOGBUFLINES,
            GTIN_EditHook,&StrEditHookNext,
            LA_ULONG,     &config2.cfg_LogBufferLines,
            LA_ID,        5,
            LA_Chars,     5,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      INTEGER_KIND,
            LA_LabelID,   PREFS_GENERAL_LOGBUFSECS,
            GTIN_EditHook,&StrEditHookNext,
            LA_ULONG,     &config2.cfg_LogBufferSecs,
            LA_ID,        6,
            LA_Chars,     5,
            TAG_DONE);

         LT_EndGroup(parthandle);

      LT_EndGroup(parthandle);

      LT_New(parthandle,
         LA_Type,      VERTICAL_KIND,
         LA_LabelID,   PREFS_GENERAL_FAKE,
         TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_GENERAL_FAKENODE,
            GTST_MaxChars,35,
            LA_Chars,     40,
            LA_ID,        7,
            LA_STRPTR,    nodebuf,
            TAG_DONE);

         LT_New(parthandle,
            LA_Type,      STRING_KIND,
            LA_LabelID,   PREFS_GENERAL_FAKEPW,
            GTST_MaxChars,8,
            LA_Chars,     8,
            LA_STRPTR,    config2.cfg_FakePW,
            LA_ID,        8,
            TAG_DONE);

      LT_EndGroup(parthandle);

   LT_EndGroup(parthandle);

   partwin=LT_Build(parthandle,LAWN_IDCMP,    IDCMP_CLOSEWINDOW|IDCMP_RAWKEY,
                               LAWN_Parent,   mainwin,
                               LAWN_HelpHook, &GeneralHelpHook,
                               LAWN_Title,    getString(PREFS_BUTTON_GENERAL),
                               WA_Flags,      WFLG_ACTIVATE|WFLG_CLOSEGADGET|WFLG_DEPTHGADGET|WFLG_DRAGBAR|WFLG_NEWLOOKMENUS,
                               TAG_END);

   if(!partwin)
   {
      LT_DeleteHandle(parthandle);
      DisplayBeep(NULL);
      return;
   }

   for(;;)
   {
      while(IntuiMessage=(struct IntuiMessage *)LT_GetIMsg(parthandle))
      {
         class=IntuiMessage->Class;
         code=IntuiMessage->Code;
         iaddress=IntuiMessage->IAddress;
         qualifier=IntuiMessage->Qualifier;

         LT_ReplyIMsg(IntuiMessage);

         switch(class)
         {
            case IDCMP_RAWKEY:        if(code == RAWKEY_TAB) LT_Activate(parthandle,1);
                                      break;

            case IDCMP_CLOSEWINDOW:   LT_DeleteHandle(parthandle);
                                      parthandle=NULL;

                                      if(Parse4D(nodebuf,&n4d))
                                         n4dcmpcpy(&config.cfg_Fake4D,&n4d);

                                      strcmpcpy(config.cfg_Sysop,config2.cfg_Sysop);
                                      strcmpcpy(config.cfg_FakePW,config2.cfg_FakePW);
                                      strcmpcpy(config.cfg_Logfile,config2.cfg_Logfile);
                                      config.cfg_Loglevel=numcmpcpy(config.cfg_Loglevel,config2.cfg_Loglevel);
                                      config.cfg_LogBufferLines=numcmpcpy(config.cfg_LogBufferLines,config2.cfg_LogBufferLines);
                                      config.cfg_LogBufferSecs=numcmpcpy(config.cfg_LogBufferSecs,config2.cfg_LogBufferSecs);
                                      config.cfg_MaxWaitPickup=numcmpcpy(config.cfg_MaxWaitPickup,config2.cfg_MaxWaitPickup);
                                      config.cfg_RaidMaxLines=numcmpcpy(config.cfg_RaidMaxLines,config2.cfg_RaidMaxLines);

                                      return;

            case IDCMP_GADGETUP:      gid=((struct Gadget *)iaddress)->GadgetID;

                                      switch(gid)
                                      {
                                         case 7:
                                          if(!Parse4D(nodebuf,&n4d))
                                          {
                                             DisplayBeep(NULL);
                                          }
                                          else
                                          {
                                             PrintFull4D(&n4d,nodebuf);
                                             LT_SetAttributes(parthandle,7,GTST_String,nodebuf,TAG_END);
                                          }
                                          break;
                                      }

                                      break;

            case IDCMP_IDCMPUPDATE:   gid=((struct Gadget *)iaddress)->GadgetID;

                                      if(gid == 3)
                                      {
                                         LT_UpdateStrings(parthandle);
                                         OpenReq(config2.cfg_Logfile,40,getString(PREFS_REQ_SELECT_FILE),partwin,FALSE);
                                         LT_SetAttributes(parthandle,3,GTST_String,config2.cfg_Logfile,TAG_END);
                                      }
                                      break;
         }
      }
      WaitPort(partwin->UserPort);
   }
}
