#include <CrashTickPrefs.h>

void strcmpcpy(uchar *dest,uchar *src)
{
   if(stricmp(dest,src)!=0)
      config.configchanged=TRUE;

   strcpy(dest,src);
}

void n4dcmpcpy(struct Node4D *dest,struct Node4D *src)
{
   if(Compare4D(dest,src)!=0)
      config.configchanged=TRUE;

   Copy4D(dest,src);
}

ulong numcmpcpy(ulong dest,ulong src)
{
   if(dest != src)
      config.configchanged=TRUE;

   return src;
}

BOOL OpenReq(UBYTE *file,ULONG varsize,UBYTE *title,struct Window *win,BOOL save)
{
   ULONG flags=0;
   APTR req;
   UBYTE buf[200],dir[200];
   APTR res;

   if(!(req=rtAllocRequest(RT_FILEREQ,TAG_END)))
   {
      DisplayBeep(NULL);
      return(FALSE);
   }

   strcpy(buf,FilePart(file));

   strcpy(dir,file);
   *(PathPart(dir))=0;

   rtChangeReqAttr(req,RTFI_Dir,dir,TAG_END);

   if(save) flags=FREQF_SAVE;

   res = rtFileRequest((struct rtFileRequester *)req,buf,title,RT_Window,      win,
                                                               RT_WaitPointer, TRUE,
                                                               RT_LockWindow,  TRUE,
                                                               RTFI_Flags,     flags,
                                                               TAG_END);

   if(res)
   {
      strncpy(file,((struct rtFileRequester *)req)->Dir,varsize-1);
      file[varsize-1]=0;
      AddPart(file,buf,varsize-1);
   }

   rtFreeRequest(req);

   if(res) return(TRUE);
   return(FALSE);
}

BOOL OpenReqDir(UBYTE *file,ULONG varsize,UBYTE *title,struct Window *win)
{
   APTR req;
   UBYTE buf[200];
   APTR res;

   if(!(req=rtAllocRequest(RT_FILEREQ,TAG_END)))
   {
      DisplayBeep(NULL);
      return(FALSE);
   }

   rtChangeReqAttr(req,RTFI_Dir,file,TAG_END);

   res = rtFileRequest((struct rtFileRequester *)req,buf,title,RT_Window,      win,
                                                               RT_WaitPointer, TRUE,
                                                               RT_LockWindow,  TRUE,
                                                               RTFI_Flags,     FREQF_NOFILES,
                                                               TAG_END);

   if(res)
   {
      strncpy(file,((struct rtFileRequester *)req)->Dir,varsize-1);
      file[varsize-1]=0;
   }

   rtFreeRequest(req);

   if(res) return(TRUE);
   return(FALSE);
}

extern APTR mempool;

void FreeTempNodes(struct List *list)
{
   struct TempNode *tn;

   while(tn=(struct TempNode *)RemHead(list))
      LibFreePooled(mempool,tn,sizeof(struct TempNode)); 
}

void jbSwapNodes(struct jbList *list,struct jbNode *n1)
{
   struct jbNode *prev,*tmp,*n2;

   prev=NULL;
   n2=n1->Next;

   for(tmp=list->First;tmp;tmp=tmp->Next)
      if(tmp->Next == n1) prev=tmp;

   if(prev)
      prev->Next=n2;

   n1->Next=n2->Next;
   n2->Next=n1;

   if(list->First == n1) list->First=n2;
   if(list->Last == n2)  list->Last=n1;
}

void MakeSmall(UBYTE *src,UBYTE *dest)
{
   ULONG c;

   for(c=0;c<strlen(src);c++)
      dest[c]=ToLower(src[c]);

   dest[c]=0;
}

struct Menu *asklistmenus;

struct NewMenu asklistnewmenus[] = {
   {NM_TITLE,"","",0,0,NULL},
   {NM_ITEM, "","",0,0,NULL},
   {NM_ITEM, "","",0,0,NULL},
   {NM_END,  "","",0,0,NULL}};

UBYTE askfindbuf[100];
struct Window *askwin;
struct LayoutHandle *askhandle;
LONG asklistres;

void AskFindNext(struct List *l);

void AskFind(struct List *l)
{
   BOOL res;

   res=rtGetString(askfindbuf,99,getString(PREFS_FINDREQ),NULL,
            RT_Window,      askwin,
            RT_WaitPointer, TRUE,
            RT_LockWindow,  TRUE,
            TAG_END);

   if(!res)
      return;

   AskFindNext(l);
}

void AskFindNext(struct List *l)
{
   struct Node *n;
   ULONG num,i;
   UBYTE findtemp[100];
   UBYTE tagtemp[100];

   if(!askfindbuf[0])
   {
      AskFind(l);
      return;
   }

   n=l->lh_Head;
   for(i=0;i<asklistres;i++) n=n->ln_Succ;

   num=asklistres+1;
   n=n->ln_Succ;

   MakeSmall(askfindbuf,findtemp);

   while(n->ln_Succ)
   {
      MakeSmall(n->ln_Name,tagtemp);

      if(strstr(tagtemp,findtemp))
      {
         break;
      }
      else
      {
         n=n->ln_Succ;
         num++;
      }
   }

   if(n->ln_Succ)
   {
      LT_SetAttributes(askhandle,4711,GTLV_Selected,num,GTLV_MakeVisible,num,TAG_END);
      asklistres=num;
   }
   else
   {
      DisplayBeep(NULL);
   }
}

LONG AskList(struct List *list,UBYTE *title,struct Window *win)
{
   struct Node *node;
   struct IntuiMessage *IntuiMessage;
   ULONG class,code,num;
   APTR iaddress;
   struct MenuItem *menuitem;

   LT_LockWindow(win);

   askhandle = LT_CreateHandleTags(win->WScreen,
                  LH_LocaleHook, &LocaleHook,
                  TAG_DONE);

   if(!askhandle)
   {
      DisplayBeep(NULL);
      LT_UnlockWindow(win);
      return(-1);
   }

   asklistnewmenus[0].nm_Label    = getString(PREFS_FINDMENU_TITLE);

   asklistnewmenus[1].nm_Label    = getString(PREFS_FINDMENU_FIND)+2;
   asklistnewmenus[1].nm_CommKey  = getString(PREFS_FINDMENU_FIND);

   asklistnewmenus[2].nm_Label    = getString(PREFS_FINDMENU_FINDNEXT)+2;
   asklistnewmenus[2].nm_CommKey  = getString(PREFS_FINDMENU_FINDNEXT);

   asklistmenus=LT_LayoutMenus(askhandle,asklistnewmenus,GTMN_FrontPen,0L,
                                                         GTMN_TextAttr,win->WScreen,
                                                         GTMN_NewLookMenus,TRUE,
                                                         LH_MenuGlyphs,TRUE,
                                                         TAG_DONE);
   if(!asklistmenus)
   {
      LT_DeleteHandle(askhandle);
      DisplayBeep(NULL);
      LT_UnlockWindow(win);
      return(-1);
   }

   LT_New(askhandle,
      LA_Type,      VERTICAL_KIND,
      TAG_DONE);

      LT_New(askhandle,
         LA_Type,       LISTVIEW_KIND,
         LALV_Lines,    15,
         LALV_CursorKey,TRUE,
         LALV_Link,     NIL_LINK,
         LALV_LockSize, TRUE,
         LA_Chars,      40,
         LA_ID,4711,
         TAG_DONE);

      LT_New(askhandle,
         LA_Type,      XBAR_KIND,
         TAG_END);

      LT_New(askhandle,
         LA_Type,      HORIZONTAL_KIND,
         LAGR_SameSize,TRUE,
         TAG_DONE);

         LT_New(askhandle,
            LA_Type,      BUTTON_KIND,
            LA_LabelID,   PREFS_TXT_OK,
            LA_Chars,19,
            GA_Disabled,   TRUE,
            LABT_ReturnKey,TRUE,
            LA_ID,10,
            TAG_DONE);

         LT_New(askhandle,
            LA_Type,      BUTTON_KIND,
            LA_LabelID,   PREFS_TXT_CANCEL,
            LA_Chars,19,
            LA_ID,11,
            TAG_DONE);

      LT_EndGroup(askhandle);

   LT_EndGroup(askhandle);

   askwin=LT_Build(askhandle,LAWN_IDCMP,    IDCMP_CLOSEWINDOW,
                             LAWN_Title,    title,
                             WA_Flags,      WFLG_ACTIVATE|WFLG_CLOSEGADGET|WFLG_DEPTHGADGET|WFLG_DRAGBAR|WFLG_NEWLOOKMENUS,
                             LAWN_Menu,     asklistmenus,
                             TAG_END);

   if(!askwin)
   {
      LT_DeleteHandle(askhandle);
	   FreeMenus(asklistmenus);
      DisplayBeep(NULL);
      LT_UnlockWindow(win);
      return(-1);
   }

   LT_SetAttributes(askhandle,4711,GTLV_Labels,list,TAG_END);

   asklistres=-1;

   num=0;

   for(node=list->lh_Head;node->ln_Succ;node=node->ln_Succ)
      num++;

   if(num)
   {
      LT_SetAttributes(askhandle,10,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(askhandle,4711,GTLV_Selected,0,TAG_END);
      asklistres=0;
   }

   for(;;)
   {
      while(IntuiMessage=(struct IntuiMessage *)LT_GetIMsg(askhandle))
      {
         class=IntuiMessage->Class;
         code=IntuiMessage->Code;
         iaddress=IntuiMessage->IAddress;

         LT_ReplyIMsg(IntuiMessage);

         switch(class)
         {
            case IDCMP_MENUPICK:       num=code;
                                       while(num!=MENUNULL)
                                       {
                                          if(MENUNUM(num)==0)
                                          {
                                             switch(ITEMNUM(num))
                                             {
                                                case 0: AskFind(list);
                                                        break;
                                                case 1: AskFindNext(list);
                                                        break;
                                             }
                                          }
                                          menuitem=ItemAddress(asklistmenus,num);
                                          num=menuitem->NextSelect;
                                       }
                                       break;

             case IDCMP_GADGETUP:      switch(((struct Gadget *)iaddress)->GadgetID)
                                       {
                                          case 10:
                                             LT_DeleteHandle(askhandle);
                                             LT_UnlockWindow(win);
                                             return(asklistres);
                                          case 11:
                                             LT_DeleteHandle(askhandle);
                                             LT_UnlockWindow(win);
                                             return(-1);
                                          case 4711:
                                             asklistres=code;
                                             LT_SetAttributes(askhandle,10,GA_Disabled,FALSE,TAG_END);
                                             break;
                                       }
                                       break;
            case IDCMP_IDCMPUPDATE:    switch(((struct Gadget *)iaddress)->GadgetID)
                                       {
                                          case 4711:
                                             LT_DeleteHandle(askhandle);
                                             LT_UnlockWindow(win);
                                       	   FreeMenus(asklistmenus);
                                             return(asklistres);
                                       }
                                       break;
            case IDCMP_CLOSEWINDOW:    LT_DeleteHandle(askhandle);
                                       LT_UnlockWindow(win);
                                       return(-1);
         }
      }
      WaitPort(askwin->UserPort);
   }
}

int MakeCNodeList(struct List *list)
{
   struct TempNode *tempnode;
   struct ConfigNode *cnode;
   ulong num;

   NewList(list);

   num=0;

   for(cnode=(struct ConfigNode *)config.CNodeList.First;cnode;cnode=cnode->Next)
   {
      if(!(tempnode=AllocCleared(sizeof(struct TempNode))))
      {
         DisplayBeep(NULL);
         FreeTempNodes(list);
         return(FALSE);
      }

      PrintFull4D(&cnode->Node,tempnode->buf);
      tempnode->Node.ln_Name=tempnode->buf;
      tempnode->UserData=cnode;
      tempnode->num=num;

      num++;

      AddTail(list,(struct Node *)tempnode);
   }

   return(TRUE);
}

struct ConfigNode *AskCNode(struct Window *win)
{
   struct List list;
   long res,c;
   struct ConfigNode *cnode;

   if(!MakeCNodeList(&list))
      return(NULL);

   res=AskList(&list,getString(PREFS_ASKLIST_SELECT_NODE),win);
   FreeTempNodes(&list);

   if(res == -1)
      return(NULL);

   cnode=(struct ConfigNode *)config.CNodeList.First;

   for(c=0;c<res;c++)
      cnode=cnode->Next;

   return(cnode);
}

int MakeAkaList(struct List *list)
{
   struct TempNode *tempnode;
   struct Aka *aka;
   ulong num;

   NewList(list);

   num=0;

   for(aka=(struct Aka *)config.AkaList.First;aka;aka=aka->Next)
   {
      if(!(tempnode=AllocCleared(sizeof(struct TempNode))))
      {
         DisplayBeep(NULL);
         FreeTempNodes(list);
         return(FALSE);
      }

      PrintFull4D(&aka->Node,tempnode->buf);
      tempnode->Node.ln_Name=tempnode->buf;
      tempnode->UserData=aka;
      tempnode->num=num;

      num++;

      AddTail(list,(struct Node *)tempnode);
   }

   return(TRUE);
}

struct Aka *AskAka(struct Window *win)
{
   struct List list;
   long res,c;
   struct Aka *aka;

   if(!MakeAkaList(&list))
      return(NULL);

   res=AskList(&list,getString(PREFS_ASKLIST_SELECT_AKA),win);
   FreeTempNodes(&list);

   if(res == -1)
      return(NULL);

   aka=(struct Aka *)config.AkaList.First;

   for(c=0;c<res;c++)
      aka=aka->Next;

   return(aka);
}

uchar AskGroup(struct Window *win,uchar *nullname)
{
   struct List list;
   long res,c;
   uchar ret;
   struct TempNode *tempnodes,*tn;

   NewList(&list);

   if(!(tempnodes=AllocCleared(27*sizeof(struct TempNode))))
   {
      DisplayBeep(NULL);
      return(255);
   }

   if(nullname)
   {
      strcpy(tempnodes[0].buf,nullname);
      tempnodes[0].UserData=0;
      tempnodes[0].num=0;
      tempnodes[0].Node.ln_Name=tempnodes[0].buf;
      AddTail(&list,(struct Node *)&tempnodes[0]);
   }

   for(c=1;c<27;c++)
   {
      sprintf(tempnodes[c].buf,"%lc: %s",'A'+c-1,config.cfg_GroupNames[c-1]);
      tempnodes[c].UserData=(APTR)('A'+c-1);
      tempnodes[c].num=c;
      tempnodes[c].Node.ln_Name=tempnodes[c].buf;
      AddTail(&list,(struct Node *)&tempnodes[c]);
   }

   res=AskList(&list,getString(PREFS_ASKLIST_SELECT_GROUP),win);

   if(res != -1)
   {
      tn=(struct TempNode *)list.lh_Head;

      for(c=0;c<res;c++)
         tn=(struct TempNode *)tn->Node.ln_Succ;

      ret=(uchar)tn->UserData;
   }
   else
   {
      ret=255;
   }

   LibFreePooled(mempool,tempnodes,27*sizeof(struct TempNode));

   return(ret);
}

BOOL CheckFlags(UBYTE group,UBYTE *node)
{
   UBYTE c;

   for(c=0;c<strlen(node);c++)
   {
      if(group==node[c])
         return(TRUE);
    }

   return(FALSE);
}

int EditGroups(uchar *groups,UBYTE *title,struct Window *win)
{
   struct IntuiMessage *IntuiMessage;
   ULONG class,code;
   APTR iaddress;
   struct List list;
   struct TempNode *tempnodes;
   ULONG c,d;

   NewList(&list);

   if(!(tempnodes=AllocCleared(26*sizeof(struct TempNode))))
   {
      DisplayBeep(NULL);
      return(FALSE);
   }

   for(c=0;c<26;c++)
   {
      if(CheckFlags('A'+c,groups))
      {
         sprintf(tempnodes[c].buf,"*%lc: %s",'A'+c,config.cfg_GroupNames[c]);
         tempnodes[c].UserData=(APTR)TRUE;
      }
      else
      {
         sprintf(tempnodes[c].buf,"%lc: %s",'A'+c,config.cfg_GroupNames[c]);
         tempnodes[c].UserData=(APTR)FALSE;
      }

      tempnodes[c].Node.ln_Name=tempnodes[c].buf;
      AddTail(&list,(struct Node *)&tempnodes[c]);
   }

   LT_LockWindow(win);

   askhandle = LT_CreateHandleTags(win->WScreen,
                  LH_LocaleHook, &LocaleHook,
                  TAG_DONE);

   if(!askhandle)
   {
      DisplayBeep(NULL);
      LT_UnlockWindow(win);
      LibFreePooled(mempool,tempnodes,26*sizeof(struct TempNode));
      return(FALSE);
   }

   LT_New(askhandle,
      LA_Type,      VERTICAL_KIND,
      TAG_DONE);

      LT_New(askhandle,
         LA_Type,       LISTVIEW_KIND,
         LALV_Lines,    15,
         LALV_CursorKey,TRUE,
         LALV_Link,     NIL_LINK,
         LALV_LockSize, TRUE,
         GTLV_Labels,   &list,
         LA_Chars,      40,
         LA_ID,4711,
         TAG_DONE);

      LT_New(askhandle,
         LA_Type,      XBAR_KIND,
         TAG_END);

      LT_New(askhandle,
         LA_Type,      HORIZONTAL_KIND,
         LAGR_SameSize,TRUE,
         TAG_DONE);

         LT_New(askhandle,
            LA_Type,      BUTTON_KIND,
            LA_LabelID,   PREFS_TXT_OK,
            LA_Chars,19,
            LABT_ReturnKey,TRUE,
            LA_ID,10,
            TAG_DONE);

         LT_New(askhandle,
            LA_Type,      BUTTON_KIND,
            LA_LabelID,   PREFS_TXT_CANCEL,
            LA_Chars,19,
            LA_ID,11,
            TAG_DONE);

      LT_EndGroup(askhandle);

   LT_EndGroup(askhandle);

   askwin=LT_Build(askhandle,LAWN_IDCMP,    IDCMP_CLOSEWINDOW,
                             LAWN_Title,    title,
                             WA_Flags,      WFLG_ACTIVATE|WFLG_CLOSEGADGET|WFLG_DEPTHGADGET|WFLG_DRAGBAR|WFLG_NEWLOOKMENUS,
                             TAG_END);

   if(!askwin)
   {
      LT_DeleteHandle(askhandle);
      DisplayBeep(NULL);
      LT_UnlockWindow(win);
      LibFreePooled(mempool,tempnodes,26*sizeof(struct TempNode));
      return(FALSE);
   }

   for(;;)
   {
      while(IntuiMessage=(struct IntuiMessage *)LT_GetIMsg(askhandle))
      {
         class=IntuiMessage->Class;
         code=IntuiMessage->Code;
         iaddress=IntuiMessage->IAddress;

         LT_ReplyIMsg(IntuiMessage);

         switch(class)
         {
              case IDCMP_GADGETUP:     switch(((struct Gadget *)iaddress)->GadgetID)
                                       {
                                          case 10:
                                             LT_DeleteHandle(askhandle);
                                             LT_UnlockWindow(win);

                                             d=0;

                                             for(c=0;c<26;c++)
                                                if(tempnodes[c].UserData) groups[d++]='A'+c;

                                             groups[d]=0;

                                             LibFreePooled(mempool,tempnodes,26*sizeof(struct TempNode));
                                             return(TRUE);

                                          case 11:
                                             LT_DeleteHandle(askhandle);
                                             LT_UnlockWindow(win);
                                             LibFreePooled(mempool,tempnodes,26*sizeof(struct TempNode));
                                             return(FALSE);
                                       }
                                       break;
            case IDCMP_IDCMPUPDATE:    switch(((struct Gadget *)iaddress)->GadgetID)
                                       {
                                          case 4711:
                                             LT_SetAttributes(askhandle,4711,GTLV_Labels,~0,TAG_END);

                                             if(tempnodes[code].UserData)
                                             {
                                                tempnodes[code].UserData=(APTR)FALSE;
                                                sprintf(tempnodes[code].buf,"%lc: %s",'A'+code,config.cfg_GroupNames[code]);
                                             }
                                             else
                                             {
                                                tempnodes[code].UserData=(APTR)TRUE;
                                                sprintf(tempnodes[code].buf,"*%lc: %s",'A'+code,config.cfg_GroupNames[code]);
                                             }

                                             LT_SetAttributes(askhandle,4711,GTLV_Labels,&list,TAG_END);
                                             break;
                                       }
                                       break;
            case IDCMP_CLOSEWINDOW:    LT_DeleteHandle(askhandle);
                                       LT_UnlockWindow(win);
                                       LibFreePooled(mempool,tempnodes,26*sizeof(struct TempNode));
                                       return(FALSE);
         }
      }
      WaitPort(askwin->UserPort);
   }
}


void RequestError(struct Window *win,char *fmt,...)
{
   va_list args;

   va_start(args,fmt);

   rtEZRequestTags(fmt,getString(PREFS_TXT_OK),NULL,args,
            RT_Underscore,    '_',
            RTEZ_ReqTitle,    getString(PREFS_REQ_ERROR_TITLE),
            RTEZ_Flags,       EZREQF_CENTERTEXT,
            RT_Window,partwin,
            RT_WaitPointer,TRUE,
            RT_LockWindow, TRUE,
            TAG_END);

   va_end(args);
}
