#include <CrashTickPrefs.h>

struct Hook NodesHelpHook = { {NULL}, HelpHookEntry,NULL,(APTR)HELP_NODES};

struct List Nodes_TempList;
struct List Nodes_TempAreaList;
struct List Nodes_TempGroupList;
struct TempNode *Nodes_CurrentNode;
struct TempNode *Nodes_CurrentAreaNode;

struct TempNode *Nodes_GroupNodes;
ulong Nodes_CurrentGroup;

ulong Nodes_Activepage;
ulong Nodes_Selectmode;

uchar *Nodes_Areaflags[4];
uchar *Nodes_Pagenames[5];
uchar *Nodes_Selectmodes[3];
uchar *Nodes_Prinames[5];
uchar *Nodes_Packmodes[4];
uchar *Nodes_Packers[4];
uchar *Nodes_Groupflags[5];

extern APTR mempool;

uchar Nodes_Groupbuf[100];

int CheckDupeNode(struct Node4D *node,struct ConfigNode *currentnode)
{
   struct ConfigNode *cnode;

   for(cnode=(struct ConfigNode *)config.CNodeList.First;cnode;cnode=cnode->Next)
      if(Compare4D(node,&cnode->Node)==0 && cnode!=currentnode) return(FALSE);

   return(TRUE);
}

void Nodes_UpdateList(void)
{
   struct TempNode *tempnode;
   struct ConfigNode *cnode;
   ulong num;

   LV_DetachList(parthandle,4000);
   FreeTempNodes(&Nodes_TempList);

   num=0;

   for(cnode=(struct ConfigNode *)config.CNodeList.First;cnode;cnode=cnode->Next)
   {
      if(tempnode=AllocCleared(sizeof(struct TempNode)))
      {
         PrintFull4D(&cnode->Node,tempnode->buf);
         tempnode->Node.ln_Name=tempnode->buf;
         tempnode->UserData=cnode;
         tempnode->num=num;

         num++;

         AddTail(&Nodes_TempList,(struct Node *)tempnode);
      }
   }

   LV_AttachList(parthandle,4000,&Nodes_TempList);
}

void Nodes_ChangedNum(void)
{
   LV_ChangedNum(parthandle,4000,&Nodes_TempList);

   if(!Nodes_TempList.lh_Head->ln_Succ)
   {
      LT_SetAttributes(parthandle,10,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,11,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,12,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,13,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,14,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,15,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,16,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,17,GA_Disabled,TRUE,TAG_END);

      LT_SetAttributes(parthandle,20,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,21,GA_Disabled,TRUE,TAG_END);

      LT_SetAttributes(parthandle,30,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,31,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,35,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,36,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,37,GA_Disabled,TRUE,TAG_END);

      LT_SetAttributes(parthandle,40,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,41,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,42,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,43,GA_Disabled,TRUE,TAG_END);

      OffMenu(partwin,FULLMENUNUM(0,0,0));
      OffMenu(partwin,FULLMENUNUM(0,2,0));
   }
   else
   {
      LT_SetAttributes(parthandle,10,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,11,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,12,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,13,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,14,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,15,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,16,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,17,GA_Disabled,FALSE,TAG_END);

      LT_SetAttributes(parthandle,20,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,21,GA_Disabled,FALSE,TAG_END);

      LT_SetAttributes(parthandle,30,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,31,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,35,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,36,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,37,GA_Disabled,FALSE,TAG_END);

      LT_SetAttributes(parthandle,40,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,41,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,42,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,43,GA_Disabled,FALSE,TAG_END);

      OnMenu(partwin,FULLMENUNUM(0,0,0));
      OnMenu(partwin,FULLMENUNUM(0,2,0));
   }
}

struct TickNode *Nodes_FindTickNode(struct Area *area,struct ConfigNode *cnode)
{
   struct TickNode *tn;
   
   for(tn=(struct TickNode *)area->TickNodes.First;tn;tn=tn->Next)
      if(tn->ConfigNode == cnode) return(tn);
      
   return(NULL);
}

void Nodes_RenumberAreaList(void)
{
   struct TempNode *tn;
   ulong c;
   
   c=0;
   
   for(tn=(struct TempNode *)Nodes_TempAreaList.lh_Head;tn->Node.ln_Succ;tn=(struct TempNode *)tn->Node.ln_Succ)
      tn->num=c++;
}

void Nodes_MakeArea(struct Area *area,struct TickNode *ticknode,struct TempNode *tn)
{
   if(ticknode->Flags & TICKNODE_READONLY)
      sprintf(tn->buf,"!%s",area->Name);

   else if(ticknode->Flags & TICKNODE_WRITEONLY)
      sprintf(tn->buf,"@%s",area->Name);

   else
      sprintf(tn->buf,"%s",area->Name);
}

void Nodes_AddAreaNode(struct Area *area)
{
   struct TickNode *ticknode;
   struct TempNode *tn;
   ulong c;

   if(!(ticknode=Nodes_FindTickNode(area,Nodes_CurrentNode->UserData)))
      return;

   if(!Nodes_TempAreaList.lh_Head->ln_Succ)
   {
      c=0;
   }
   else
   {
      tn=(struct TempNode *)Nodes_TempAreaList.lh_TailPred;
      c=tn->num+1;
   }

   if(!(tn=AllocCleared(sizeof(struct TempNode))))
      return;

   tn->UserData=area;
   tn->num=c;
   tn->Node.ln_Name=tn->buf;
   Nodes_MakeArea(area,ticknode,tn);
   AddTail(&Nodes_TempAreaList,(struct Node *)tn);
}

void Nodes_ChangedAreaNum(void)
{
   if(Nodes_TempAreaList.lh_Head->ln_Succ)
   {
      LT_SetAttributes(parthandle,30,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,31,GA_Disabled,FALSE,TAG_END);
      LT_SetAttributes(parthandle,37,GA_Disabled,FALSE,TAG_END);
   }
   else
   {
      LT_SetAttributes(parthandle,30,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,31,GA_Disabled,TRUE,TAG_END);
      LT_SetAttributes(parthandle,37,GA_Disabled,TRUE,TAG_END);
   }
}

void Nodes_UpdateAreaList(void)
{
   struct Area *area;

   FreeTempNodes(&Nodes_TempAreaList);
   LT_SetAttributes(parthandle,30,GTLV_Labels,~0,TAG_END);

   for(area=(struct Area *)config.AreaList.First;area;area=area->Next)
      Nodes_AddAreaNode(area);

   LT_SetAttributes(parthandle,30,GTLV_Labels,&Nodes_TempAreaList,TAG_END);
}

void Nodes_SetCurrentArea(ulong num)
{
   ulong c;
   struct Area *area;
   struct TickNode *ticknode;
   struct ConfigNode *cnode;

   if(!Nodes_TempAreaList.lh_Head->ln_Succ)
   {
      Nodes_CurrentAreaNode=NULL;
      return;
   }

   Nodes_CurrentAreaNode=(struct TempNode *)Nodes_TempAreaList.lh_Head;

   for(c=0;c<num;c++)
      Nodes_CurrentAreaNode=(struct TempNode *)Nodes_CurrentAreaNode->Node.ln_Succ;

   LT_SetAttributes(parthandle,30,GTLV_Selected,num,TAG_END);

   if(num == 0)
      LT_SetAttributes(parthandle,30,GTLV_MakeVisible,num,TAG_END);

   area=Nodes_CurrentAreaNode->UserData;
   cnode=Nodes_CurrentNode->UserData;

   if((ticknode=Nodes_FindTickNode(area,cnode)))
   {
      if(ticknode->Flags & TICKNODE_READONLY)
         LT_SetAttributes(parthandle,31,GTCY_Active,1,TAG_END);

      else if(ticknode->Flags & TICKNODE_WRITEONLY)
         LT_SetAttributes(parthandle,31,GTCY_Active,2,TAG_END);

      else
         LT_SetAttributes(parthandle,31,GTCY_Active,0,TAG_END);
   }
}

void Nodes_SetCurrentGroup(ulong num)
{
   struct ConfigNode *cnode;

   cnode=Nodes_CurrentNode->UserData;
   Nodes_CurrentGroup=num;

   if(CheckFlags('A'+num,cnode->FullAccessGroups))
      LT_SetAttributes(parthandle,21,GTCY_Active,1,TAG_END);

   else if(CheckFlags('A'+num,cnode->ReadOnlyGroups))
      LT_SetAttributes(parthandle,21,GTCY_Active,2,TAG_END);

   else if(CheckFlags('A'+num,cnode->WriteOnlyGroups))
      LT_SetAttributes(parthandle,21,GTCY_Active,3,TAG_END);

   else
      LT_SetAttributes(parthandle,21,GTCY_Active,0,TAG_END);

   if(num == 0)
   {
      LT_SetAttributes(parthandle,20,GTLV_Selected,num,TAG_END);
      LT_SetAttributes(parthandle,20,GTLV_MakeVisible,num,TAG_END);
   }
}

void Nodes_MakeGroupNode(uchar group,struct TempNode *tn)
{
   struct ConfigNode *cnode;

   cnode=Nodes_CurrentNode->UserData;

   if(CheckFlags(group,cnode->FullAccessGroups))
      sprintf(tn->buf,"*%lc: %s",group,config.cfg_GroupNames[group-'A']);

   else if(CheckFlags(group,cnode->ReadOnlyGroups))
      sprintf(tn->buf,"!%lc: %s",group,config.cfg_GroupNames[group-'A']);

   else if(CheckFlags(group,cnode->WriteOnlyGroups))
      sprintf(tn->buf,"@%lc: %s",group,config.cfg_GroupNames[group-'A']);

   else
      sprintf(tn->buf,"%lc: %s",group,config.cfg_GroupNames[group-'A']);
}

void Nodes_UpdateGroupList(void)
{
   ulong c;
   struct ConfigNode *cnode;

   cnode=Nodes_CurrentNode->UserData;

   LT_SetAttributes(parthandle,20,GTLV_Labels,~0,TAG_END);

   c=0;

   for(c=0;c<26;c++)
      Nodes_MakeGroupNode('A'+c,&Nodes_GroupNodes[c]);

   LT_SetAttributes(parthandle,20,GTLV_Labels,&Nodes_TempGroupList,TAG_END);
}

/*

   types:

   0: no access
   1: full access
   2: read-only

*/

void Nodes_SetGroup(ulong type)
{
   uchar destgroup[30];
   ulong c,d;
   struct ConfigNode *cnode;

   cnode=Nodes_CurrentNode->UserData;

   d=0;

   for(c=0;c<26;c++)
   {
      if(c == Nodes_CurrentGroup)
      {
         if(type == 1)
            destgroup[d++]='A'+c;
      }
      else
      {
         if(CheckFlags('A'+c,cnode->FullAccessGroups))
            destgroup[d++]='A'+c;
      }
   }

   destgroup[d]=0;
   strcpy(cnode->FullAccessGroups,destgroup);

   d=0;

   for(c=0;c<26;c++)
   {
      if(c == Nodes_CurrentGroup)
      {
         if(type == 2)
            destgroup[d++]='A'+c;
      }
      else
      {
         if(CheckFlags('A'+c,cnode->ReadOnlyGroups))
            destgroup[d++]='A'+c;
      }
   }

   destgroup[d]=0;
   strcpy(cnode->ReadOnlyGroups,destgroup);

   d=0;

   for(c=0;c<26;c++)
   {
      if(c == Nodes_CurrentGroup)
      {
         if(type == 3)
            destgroup[d++]='A'+c;
      }
      else
      {
         if(CheckFlags('A'+c,cnode->WriteOnlyGroups))
            destgroup[d++]='A'+c;
      }
   }

   destgroup[d]=0;
   strcpy(cnode->WriteOnlyGroups,destgroup);

   Nodes_UpdateGroupList();
   Nodes_SetCurrentGroup(Nodes_CurrentGroup);
   config.configchanged=TRUE;
}

void Nodes_SetCurrent(ulong num)
{
   ulong c;
   struct ConfigNode *cnode;

   if(!Nodes_TempList.lh_Head->ln_Succ)
   {
      LV_SetCurrent(parthandle,4000,&Nodes_TempList,NULL);
      Nodes_CurrentNode=NULL;
      return;
   }

   Nodes_CurrentNode=(struct TempNode *)Nodes_TempList.lh_Head;

   for(c=0;c<num;c++)
      Nodes_CurrentNode=(struct TempNode *)Nodes_CurrentNode->Node.ln_Succ;

   LV_SetCurrent(parthandle,4000,&Nodes_TempList,Nodes_CurrentNode);

   cnode=Nodes_CurrentNode->UserData;

   if(Nodes_Activepage == 0)
   {
      LT_SetAttributes(parthandle,10,GTST_String,cnode->TickPW,TAG_END);
      LT_SetAttributes(parthandle,11,GTCY_Active,cnode->Pri,TAG_END);
      LT_SetAttributes(parthandle,12,GTCY_Active,cnode->Packmode,TAG_END);
      LT_SetAttributes(parthandle,13,GTCY_Active,cnode->Packer,TAG_END);

      LT_SetAttributes(parthandle,14,GTCB_Checked,FALSE,TAG_END);
      LT_SetAttributes(parthandle,15,GTCB_Checked,FALSE,TAG_END);
      LT_SetAttributes(parthandle,16,GTCB_Checked,FALSE,TAG_END);
      LT_SetAttributes(parthandle,17,GTCB_Checked,FALSE,TAG_END);

      if(cnode->Flags & NODE_TINYSEENBY)
         LT_SetAttributes(parthandle,14,GTCB_Checked,TRUE,TAG_END);

      if(cnode->Flags & NODE_AUTOADD)
         LT_SetAttributes(parthandle,15,GTCB_Checked,TRUE,TAG_END);

      if(cnode->Flags & NODE_PASSIVE)
         LT_SetAttributes(parthandle,16,GTCB_Checked,TRUE,TAG_END);

      if(cnode->Flags & NODE_NOTICFILES)
         LT_SetAttributes(parthandle,17,GTCB_Checked,TRUE,TAG_END);

   }

   if(Nodes_Activepage == 1)
   {
      Nodes_UpdateGroupList();
      Nodes_SetCurrentGroup(0);
   }

   if(Nodes_Activepage == 2)
   {
      Nodes_UpdateAreaList();
      Nodes_ChangedAreaNum();
      Nodes_SetCurrentArea(0);
   }

   if(Nodes_Activepage == 3)
   {
      LT_SetAttributes(parthandle,40,GTST_String,cnode->SysopName,TAG_END);
      LT_SetAttributes(parthandle,41,GTST_String,cnode->RaidPW,TAG_END);

      if(cnode->DefaultGroup == 0)
         strcpy(Nodes_Groupbuf,getString(PREFS_NO_GROUP));

      else
         sprintf(Nodes_Groupbuf,"%lc: %s",
            cnode->DefaultGroup,config.cfg_GroupNames[cnode->DefaultGroup-'A']);

      LT_SetAttributes(parthandle,42,GTTX_Text,Nodes_Groupbuf,TAG_END);

      LT_SetAttributes(parthandle,43,GTCB_Checked,FALSE,TAG_END);

      if(cnode->Flags & NODE_NOTIFY)
         LT_SetAttributes(parthandle,43,GTCB_Checked,TRUE,TAG_END);
   }

}

void Nodes_UpdateConfig(void)
{
   struct ConfigNode *cnode;
   ulong oldflags,newflags;

   if(!Nodes_CurrentNode)
      return;

   cnode=Nodes_CurrentNode->UserData;

   if(Nodes_Activepage == 0)
   {
      strcmpcpy(cnode->TickPW,(uchar *)LT_GetAttributes(parthandle,10,TAG_END));

      cnode->Pri=numcmpcpy(cnode->Pri,LT_GetAttributes(parthandle,11,TAG_END));
      cnode->Packmode=numcmpcpy(cnode->Packmode,LT_GetAttributes(parthandle,12,TAG_END));
      cnode->Packer=numcmpcpy(cnode->Packer,LT_GetAttributes(parthandle,13,TAG_END));

      newflags=0;
      oldflags=cnode->Flags & (NODE_TINYSEENBY|NODE_AUTOADD|NODE_PASSIVE|NODE_NOTICFILES);
      cnode->Flags &= ~(NODE_TINYSEENBY|NODE_AUTOADD|NODE_PASSIVE|NODE_NOTICFILES);

      if(LT_GetAttributes(parthandle,14,TAG_END))
         newflags|=NODE_TINYSEENBY;

      if(LT_GetAttributes(parthandle,15,TAG_END))
         newflags|=NODE_AUTOADD;

      if(LT_GetAttributes(parthandle,16,TAG_END))
         newflags|=NODE_PASSIVE;

      if(LT_GetAttributes(parthandle,17,TAG_END))
         newflags|=NODE_NOTICFILES;

      if(newflags != oldflags)
         config.configchanged=TRUE;

      cnode->Flags|=newflags;
   }

   if(Nodes_Activepage == 3)
   {
      strcmpcpy(cnode->SysopName,(uchar *)LT_GetAttributes(parthandle,40,TAG_END));
      strcmpcpy(cnode->RaidPW,(uchar *)LT_GetAttributes(parthandle,41,TAG_END));

      newflags=0;
      oldflags=cnode->Flags & (NODE_NOTIFY);
      cnode->Flags &= ~(NODE_NOTIFY);

      if(LT_GetAttributes(parthandle,43,TAG_END))
         newflags|=NODE_NOTIFY;

      if(newflags != oldflags)
         config.configchanged=TRUE;

      cnode->Flags|=newflags;
   }
}

void Nodes_Add(void)
{
   BOOL res;
   struct ConfigNode *cnode;
   UBYTE buf[80];
   struct TempNode *tn;
   short kg;
   struct Node4D n4d;

   buf[0]=0;

   kg=TRUE;

   while(kg)
   {
      res=rtGetString(buf,79,getString(PREFS_LIST_ADD),NULL,
               RTGS_TextFmt,getString(PREFS_NODES_ADD),
               RTGS_Flags, GSREQF_CENTERTEXT,
               RT_Window,  partwin,
               RT_WaitPointer, TRUE,
               RT_LockWindow, TRUE,
               RT_Underscore,'_',
               TAG_END);

      if(!res)
         return;

      if(Parse4D(buf,&n4d))
      {
         if(CheckDupeNode(&n4d,NULL))
         {
            kg=FALSE;
         }
         else
         {
            RequestError(partwin,getString(PREFS_NODES_ALREADY_HAS),
               n4d.Zone,
               n4d.Net,
               n4d.Node,
               n4d.Point);
         }
      }
      else
      {
         RequestError(partwin,getString(CFG_ERR_INVALID_NODE),buf);
      }
   }

   if(!(cnode=AllocCleared(sizeof(struct ConfigNode))))
   {
      DisplayBeep(NULL);
      return;
   }

   Copy4D(&cnode->Node,&n4d);
   jbAddNode(&config.CNodeList,(struct jbNode *)cnode);
   Nodes_UpdateList();

   tn=(struct TempNode *)Nodes_TempList.lh_TailPred;

   Nodes_ChangedNum();
   Nodes_SetCurrent(tn->num);
   config.configchanged=TRUE;
}

void Nodes_AddArea(void)
{
   ulong res;
   struct List list;
   struct ConfigNode *cnode;
   struct TempNode *tn;
   struct TickNode *ticknode;
   struct Area *area;
   ulong c;

   NewList(&list);

   cnode=Nodes_CurrentNode->UserData;
   c=0;

   for(area=(struct Area *)config.AreaList.First;area;area=area->Next)
   {
      ticknode=Nodes_FindTickNode(area,cnode);

      if(!ticknode)
      {
         if(Nodes_Selectmode == 0 || CheckFlags(area->Group,cnode->ReadOnlyGroups) || CheckFlags(area->Group,cnode->FullAccessGroups) || CheckFlags(area->Group,cnode->WriteOnlyGroups))
         {
            if(tn=AllocCleared(sizeof(struct TempNode)))
            {
               strcpy(tn->buf,area->Name);
               tn->UserData=area;
               tn->num=c;
               tn->Node.ln_Name=tn->buf;
               AddTail(&list,(struct Node *)tn);

               c++;
            }
         }
      }
   }

   res=AskList(&list,getString(PREFS_ASKLIST_SELECT_AREA),partwin);

   if(res == -1)
   {
      FreeTempNodes(&list);
      return;
   }

   tn=(struct TempNode *)list.lh_Head;

   for(c=0;c<res;c++)
      tn=(struct TempNode *)tn->Node.ln_Succ;

   area=tn->UserData;
   FreeTempNodes(&list);

   if(!(ticknode=AllocCleared(sizeof(struct TickNode))))
      return;

   ticknode->ConfigNode=cnode;

   if(CheckFlags(area->Group,cnode->ReadOnlyGroups) || (area->Flags & AREA_DEFREADONLY))
      ticknode->Flags = TICKNODE_READONLY;

   if(CheckFlags(area->Group,cnode->WriteOnlyGroups))
      ticknode->Flags = TICKNODE_WRITEONLY;

   jbAddNode(&area->TickNodes,(struct jbNode *)ticknode);

   LT_SetAttributes(parthandle,30,GTLV_Labels,~0,TAG_END);
   Nodes_AddAreaNode(area);
   Nodes_ChangedAreaNum();
   LT_SetAttributes(parthandle,30,GTLV_Labels,&Nodes_TempAreaList,TAG_END);

   tn=(struct TempNode *)Nodes_TempAreaList.lh_TailPred;

   Nodes_SetCurrentArea(tn->num);
   config.configchanged=TRUE;
}

void Nodes_AddMandatory(void)
{
   struct ConfigNode *cnode;
   struct TempNode *tn;
   struct TickNode *ticknode;
   struct Area *area;
   ulong c;

   cnode=Nodes_CurrentNode->UserData;
   c=0;

   LT_SetAttributes(parthandle,30,GTLV_Labels,~0,TAG_END);

   for(area=(struct Area *)config.AreaList.First;area;area=area->Next)
   {
      if((area->Flags & AREA_MANDATORY) && (CheckFlags(area->Group,cnode->ReadOnlyGroups) || CheckFlags(area->Group,cnode->FullAccessGroups) || (CheckFlags(area->Group,cnode->WriteOnlyGroups))))
      {
         if(!Nodes_FindTickNode(area,cnode))
         {
            if((ticknode=AllocCleared(sizeof(struct TickNode))))
            {
               if(CheckFlags(area->Group,cnode->ReadOnlyGroups) || (area->Flags & AREA_DEFREADONLY))
                  ticknode->Flags = TICKNODE_READONLY;

               if(CheckFlags(area->Group,cnode->WriteOnlyGroups))
                  ticknode->Flags = TICKNODE_WRITEONLY;

               ticknode->ConfigNode=cnode;
               jbAddNode(&area->TickNodes,(struct jbNode *)ticknode);
               Nodes_AddAreaNode(area);
            }
         }
      }
   }

   Nodes_ChangedAreaNum();
   LT_SetAttributes(parthandle,30,GTLV_Labels,&Nodes_TempAreaList,TAG_END);

   tn=(struct TempNode *)Nodes_TempAreaList.lh_TailPred;

   Nodes_SetCurrentArea(tn->num);
   config.configchanged=TRUE;
}

void Nodes_Duplicate(void)
{
   BOOL res;
   struct ConfigNode *cnode,*oldcnode;
   struct TickNode *ticknode,*oldticknode;
   struct Area *area;
   UBYTE buf[80];
   struct TempNode *tn;
   BOOL kg;
   struct Node4D n4d;
   
   oldcnode=Nodes_CurrentNode->UserData;
   PrintFull4D(&oldcnode->Node,buf);

   kg=TRUE;

   while(kg)
   {
      res=rtGetString(buf,79,getString(PREFS_LIST_ADD),NULL,
               RTGS_TextFmt,getString(PREFS_NODES_ADD),
               RTGS_Flags, GSREQF_CENTERTEXT,
               RT_Window,  partwin,
               RT_WaitPointer, TRUE,
               RT_LockWindow, TRUE,
               RT_Underscore,'_',
               TAG_END);

      if(!res)
         return;

      if(Parse4D(buf,&n4d))
      {
         if(CheckDupeNode(&n4d,NULL))
         {
            kg=FALSE;
         }
         else
         {
            RequestError(partwin,getString(PREFS_NODES_ALREADY_HAS),
               n4d.Zone,
               n4d.Net,
               n4d.Node,
               n4d.Point);
         }
      }
      else
      {
         RequestError(partwin,getString(CFG_ERR_INVALID_NODE),buf);
      }
   }

   if(!(cnode=AllocCleared(sizeof(struct ConfigNode))))
   {
      DisplayBeep(NULL);
      return;
   }

   Copy4D(&cnode->Node,&n4d);
   strcpy(cnode->TickPW,oldcnode->TickPW);
   cnode->Pri=oldcnode->Pri;
   cnode->Packer=oldcnode->Packer;
   cnode->Packmode=oldcnode->Packmode;
   cnode->Flags=oldcnode->Flags;
   strcpy(cnode->FullAccessGroups,oldcnode->FullAccessGroups);
   strcpy(cnode->ReadOnlyGroups,oldcnode->ReadOnlyGroups);
   strcpy(cnode->WriteOnlyGroups,oldcnode->WriteOnlyGroups);
   strcpy(cnode->SysopName,oldcnode->SysopName);
   strcpy(cnode->RaidPW,oldcnode->RaidPW);
   cnode->DefaultGroup=oldcnode->DefaultGroup;
   jbAddNode(&config.CNodeList,(struct jbNode *)cnode);

   for(area=(struct Area *)config.AreaList.First;area;area=area->Next)
   {
      if((oldticknode=Nodes_FindTickNode(area,oldcnode)))
      {
         if(ticknode=AllocCleared(sizeof(struct TickNode)))
         {
            ticknode->Flags=oldticknode->Flags;
            ticknode->ConfigNode=cnode;
            jbAddNode(&area->TickNodes,(struct jbNode *)ticknode);
         }
      }
   }

   Nodes_UpdateList();

   tn=(struct TempNode *)Nodes_TempList.lh_TailPred;

   Nodes_ChangedNum();
   Nodes_SetCurrent(tn->num);
   config.configchanged=TRUE;
}

void Nodes_Remove(void)
{
   struct ConfigNode *cnode;
   struct Area *area;
   struct TickNode *ticknode,*ticknode2;
   ulong areas;
   UBYTE buf[400];
   BOOL res;
   ULONG tmp;

   cnode=Nodes_CurrentNode->UserData;

   areas=0;

   for(area=(struct Area *)config.AreaList.First;area;area=area->Next)
      if(Nodes_FindTickNode(area,cnode)) areas++;

   sprintf(buf,getString(PREFS_NODES_REM),
      cnode->Node.Zone,
      cnode->Node.Net,
      cnode->Node.Node,
      cnode->Node.Point,
      areas);

   res=rtEZRequestTags(buf,getString(PREFS_TXT_REMOVE_CANCEL),NULL,NULL,
      RT_Underscore,'_',
      RT_Window,partwin,
      RT_WaitPointer,TRUE,
      RT_LockWindow, TRUE,
      RTEZ_Flags, EZREQF_CENTERTEXT | EZREQF_NORETURNKEY,
      TAG_END);

   if(!res)
      return;

   tmp=Nodes_CurrentNode->num;

   if(!Nodes_CurrentNode->Node.ln_Succ->ln_Succ)
      tmp--;

   for(area=(struct Area *)config.AreaList.First;area;area=area->Next)
   {
      ticknode=(struct TickNode *)area->TickNodes.First;

      while(ticknode)
      {
         ticknode2=ticknode->Next;

         if(ticknode->ConfigNode == cnode)
            jbFreeNode(&area->TickNodes,(struct jbNode *)ticknode,sizeof(struct TickNode));

         ticknode=ticknode2;
      }
   }

   jbFreeNode(&config.CNodeList,(struct jbNode *)Nodes_CurrentNode->UserData,sizeof(struct ConfigNode));

   Nodes_UpdateList();
   Nodes_ChangedNum();
   Nodes_SetCurrent(tmp);

   config.configchanged=TRUE;
}

struct NewMenu nodenewmenus[] = { {NM_TITLE,"",NULL,0,0,NULL},                     /* >Edit               */
                                  {NM_ITEM, "",NULL,0,0,NULL},                     /* Duplicate...        */
                                  {NM_ITEM, (STRPTR)NM_BARLABEL,NULL,0,0,NULL},    /* ~~~~~~~~~~~~~~~~~~~ */
                                  {NM_ITEM, "",NULL,0,0,NULL},                     /* Add mandatory areas */
                                  {NM_END,  "",NULL,0,0,NULL}};

void PartNodes(void)
{
   struct IntuiMessage *IntuiMessage;
   APTR iaddress;
   ULONG class,code,qualifier;
   struct ConfigNode *cnode;
   struct Menu *nodemenus;
   struct MenuItem *menuitem;
   ulong num,tmp,c;
   uchar group;
   struct TickNode *ticknode;
   struct Area *area;
   struct Node4D n4d;

   if(!(Nodes_GroupNodes=AllocCleared(26*sizeof(struct TempNode))))
   {
      DisplayBeep(NULL);
      return;
   }

   Nodes_Activepage=0;
   Nodes_Selectmode=0;

   Nodes_Areaflags[0]=getString(PREFS_NODEACCESS_FULL);
   Nodes_Areaflags[1]=getString(PREFS_NODEACCESS_NOHATCH);
   Nodes_Areaflags[2]=getString(PREFS_NODEACCESS_HATCHONLY);
   Nodes_Areaflags[3]=NULL;

   Nodes_Pagenames[0]=getString(PREFS_NODES_PAGE_GENERAL);
   Nodes_Pagenames[1]=getString(PREFS_NODES_PAGE_GROUPS);
   Nodes_Pagenames[2]=getString(PREFS_NODES_PAGE_AREAS);
   Nodes_Pagenames[3]=getString(PREFS_NODES_PAGE_RAID);
   Nodes_Pagenames[4]=NULL;

   Nodes_Selectmodes[0]=getString(PREFS_SELECTMODE_ALL);
   Nodes_Selectmodes[1]=getString(PREFS_SELECTMODE_ACCESS);
   Nodes_Selectmodes[2]=NULL;

   Nodes_Areaflags[0]=getString(PREFS_NODEACCESS_FULL);
   Nodes_Areaflags[1]=getString(PREFS_NODEACCESS_NOHATCH);
   Nodes_Areaflags[2]=getString(PREFS_NODEACCESS_HATCHONLY);
   Nodes_Areaflags[3]=NULL;

   Nodes_Packers[0]=getString(PREFS_NODE_PACKER_NONE);
   Nodes_Packers[1]="Zip";
   Nodes_Packers[2]="LhA";
   Nodes_Packers[3]=NULL;

   Nodes_Packmodes[0]=getString(PREFS_NODE_PACKMODE_NOPACK);
   Nodes_Packmodes[1]=getString(PREFS_NODE_PACKMODE_PACKALL);
   Nodes_Packmodes[2]=getString(PREFS_NODE_PACKMODE_PACKTICK);
   Nodes_Packmodes[3]=NULL;

   Nodes_Prinames[0]=getString(PREFS_NODE_PRI_NORMAL);
   Nodes_Prinames[1]=getString(PREFS_NODE_PRI_HOLD);
   Nodes_Prinames[2]=getString(PREFS_NODE_PRI_DIRECT);
   Nodes_Prinames[3]=getString(PREFS_NODE_PRI_CRASH);
   Nodes_Prinames[4]=NULL;

   Nodes_Groupflags[0]=getString(PREFS_NODEACCESS_NO);
   Nodes_Groupflags[1]=getString(PREFS_NODEACCESS_FULL);
   Nodes_Groupflags[2]=getString(PREFS_NODEACCESS_NOHATCH);
   Nodes_Groupflags[3]=getString(PREFS_NODEACCESS_HATCHONLY);
   Nodes_Groupflags[4]=NULL;

   NewList(&Nodes_TempList);
   NewList(&Nodes_TempAreaList);
   NewList(&Nodes_TempGroupList);

   for(c=0;c<26;c++)
   {
      Nodes_GroupNodes[c].UserData=NULL;
      Nodes_GroupNodes[c].num=c;
      Nodes_GroupNodes[c].Node.ln_Name=Nodes_GroupNodes[c].buf;
      AddTail(&Nodes_TempGroupList,(struct Node *)&Nodes_GroupNodes[c]);
   }

   parthandle = LT_CreateHandleTags(scr,LH_EditHook,     &StrEditHook,
                                        LH_RawKeyFilter, FALSE,
                                        LH_LocaleHook,   &LocaleHook,
                                        TAG_DONE);

   if(!parthandle)
   {
      LibFreePooled(mempool,Nodes_GroupNodes,26*sizeof(struct TempNode));
      return;
   }

   nodenewmenus[0].nm_Label   = getString(PREFS_EDITMENU_EDIT);

   nodenewmenus[1].nm_CommKey = getString(PREFS_EDITMENU_DUP);
   nodenewmenus[1].nm_Label   = getString(PREFS_EDITMENU_DUP)+2;

   nodenewmenus[3].nm_CommKey = getString(PREFS_EDITMENU_NODES_MANDATORY);
   nodenewmenus[3].nm_Label   = getString(PREFS_EDITMENU_NODES_MANDATORY)+2;

   nodemenus=LT_LayoutMenus(parthandle,nodenewmenus,
         GTMN_FrontPen,        0L,
         GTMN_TextAttr,        scr->Font,
         GTMN_NewLookMenus,    TRUE,
         LH_MenuGlyphs,        TRUE,
         TAG_DONE);

	if(!nodemenus)
   {
      DisplayBeep(NULL);
      LibFreePooled(mempool,Nodes_GroupNodes,26*sizeof(struct TempNode));
      LT_DeleteHandle(parthandle);
      return;
   }

   LT_New(parthandle,
      LA_Type, HORIZONTAL_KIND,
      LA_LabelID, PREFS_AREAS_AREAS,
      TAG_DONE);

      LT_New(parthandle,
         LA_Type,      VERTICAL_KIND,
         TAG_DONE);

         LV_CreateListView(parthandle,14,4000);

      LT_EndGroup(parthandle);

      LT_New(parthandle,
         LA_Type,      VERTICAL_KIND,
         TAG_DONE);

         LT_New(parthandle,
            LA_Type,      HORIZONTAL_KIND,
            TAG_DONE);

            LT_New(parthandle,
               LA_LabelID,       PREFS_PAGE,
               LA_Type,          CYCLE_KIND,
               LA_Chars,         30,
               LA_ID,            100,
               GTCY_Labels,      Nodes_Pagenames,
               TAG_DONE);

         LT_EndGroup(parthandle);

         LT_New(parthandle,
             LA_Type,      VERTICAL_KIND,
             LA_ID,        99,
             LAGR_ActivePage,0,
             TAG_DONE);

            LT_New(parthandle,
               LA_Type,      VERTICAL_KIND,
               TAG_DONE);

               LT_New(parthandle,
                  LA_Type,      VERTICAL_KIND,
                  LA_LabelID,   PREFS_NODES_PAGE_GENERAL,
                  TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_TICKPW,
                     LA_Chars,         20,
                     LA_Type,          STRING_KIND,
                     GTST_MaxChars,    19,
                     LA_ID,            10,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_SENDPRI,
                     LA_Type,          CYCLE_KIND,
                     LA_ID,            11,
                     GTCY_Labels,      Nodes_Prinames,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_PACKMODE,
                     LA_Type,          CYCLE_KIND,
                     LA_ID,            12,
                     GTCY_Labels,      Nodes_Packmodes,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_PACKER,
                     LA_Type,          CYCLE_KIND,
                     LA_ID,            13,
                     GTCY_Labels,      Nodes_Packers,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_TINYSEENBY,
                     LA_Type,          CHECKBOX_KIND,
                     LA_ID,            14,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_AUTOADD,
                     LA_Type,          CHECKBOX_KIND,
                     LA_ID,            15,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_PASSIVE,
                     LA_Type,          CHECKBOX_KIND,
                     LA_ID,            16,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODE_NOTICFILES,
                     LA_Type,          CHECKBOX_KIND,
                     LA_ID,            17,
                     TAG_DONE);

               LT_EndGroup(parthandle);

            LT_EndGroup(parthandle);

            LT_New(parthandle,
               LA_Type,      VERTICAL_KIND,
               TAG_DONE);

               LT_New(parthandle,
                  LA_Type,      VERTICAL_KIND,
                  LA_LabelID,   PREFS_NODES_PAGE_GROUPS,
                  TAG_DONE);

                  LT_New(parthandle,
                     LA_Type,      VERTICAL_KIND,
                     TAG_DONE);

                     LT_New(parthandle,
                        LA_Type,       LISTVIEW_KIND,
                        LA_Lines,      12,
                        LALV_Link,     NIL_LINK,
                        LA_Chars,      31,
                        LALV_LockSize, TRUE,
                        LA_ID,         20,
                        TAG_DONE);

                  LT_EndGroup(parthandle);

                  LT_New(parthandle,
                     LA_Type,          CYCLE_KIND,
                     GTCY_Labels,      Nodes_Groupflags,
                     LA_ID,            21,
                     TAG_DONE);

               LT_EndGroup(parthandle);

            LT_EndGroup(parthandle);

            LT_New(parthandle,
               LA_Type,      VERTICAL_KIND,
               TAG_DONE);

               LT_New(parthandle,
                  LA_Type,      VERTICAL_KIND,
                  LA_LabelID,   PREFS_NODES_PAGE_AREAS,
                  TAG_DONE);

                  LT_New(parthandle,
                     LA_Type,      VERTICAL_KIND,
                     TAG_DONE);

                     LT_New(parthandle,
                        LA_Type,       LISTVIEW_KIND,
                        LA_Lines,      9,
                        LALV_Link,     NIL_LINK,
                        LA_Chars,      31,
                        LALV_LockSize, TRUE,
                        LA_ID,         30,
                        TAG_DONE);

                  LT_EndGroup(parthandle);

                  LT_New(parthandle,
                     LA_Type,          CYCLE_KIND,
                     GTCY_Labels,      Nodes_Areaflags,
                     LA_ID,            31,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_Type,          XBAR_KIND,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_Type,          CYCLE_KIND,
                     GTCY_Labels,      Nodes_Selectmodes,
                     LA_ID,            35,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_Type,      HORIZONTAL_KIND,
                     TAG_DONE);

                     LT_New(parthandle,
                        LA_Type,    BUTTON_KIND,
                        LA_LabelID, PREFS_NODES_ADDGAD,
                        LA_Chars,   15,
                        LA_ID,      36,
                        TAG_DONE);

                     LT_New(parthandle,
                        LA_Type,    BUTTON_KIND,
                        LA_LabelID, PREFS_NODES_REMOVEGAD,
                        LA_Chars,   15,
                        LA_ID,      37,
                        TAG_DONE);

                  LT_EndGroup(parthandle);

               LT_EndGroup(parthandle);

            LT_EndGroup(parthandle);

            LT_New(parthandle,
               LA_Type,      VERTICAL_KIND,
               TAG_DONE);

               LT_New(parthandle,
                  LA_Type,      VERTICAL_KIND,
                  LA_LabelID,   PREFS_NODES_PAGE_RAID,
                  TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_SYSOPNAME,
                     LA_Chars,         20,
                     LA_Type,          STRING_KIND,
                     GTST_MaxChars,    35,
                     LA_ID,            40,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_RAIDPW,
                     LA_Chars,         20,
                     LA_Type,          STRING_KIND,
                     GTST_MaxChars,    39,
                     LA_ID,            41,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_DEFAULTGROUP,
                     LA_Chars,         20,
                     LA_Type,          TEXT_KIND,
                     LATX_LockSize,    TRUE,
                     LATX_Picker,      TRUE,
                     GTTX_Border,      TRUE,
                     LA_ID,            42,
                     TAG_DONE);

                  LT_New(parthandle,
                     LA_LabelID,       PREFS_NODES_NOTIFY,
                     LA_Type,          CHECKBOX_KIND,
                     LA_ID,            43,
                     TAG_DONE);

               LT_EndGroup(parthandle);

            LT_EndGroup(parthandle);

         LT_EndGroup(parthandle);

      LT_EndGroup(parthandle);

   LT_EndGroup(parthandle);

   partwin=LT_Build(parthandle,LAWN_IDCMP,    IDCMP_CLOSEWINDOW|IDCMP_RAWKEY,
                               LAWN_Parent,   mainwin,
                               LAWN_HelpHook, &NodesHelpHook,
                               LAWN_Title,    getString(PREFS_BUTTON_NODES),
                               WA_Flags,      WFLG_ACTIVATE|WFLG_CLOSEGADGET|WFLG_DEPTHGADGET|WFLG_DRAGBAR|WFLG_NEWLOOKMENUS,
                               LAWN_Menu,     nodemenus,
                               TAG_END);

   if(!partwin)
   {
      LT_DeleteHandle(parthandle);
	   FreeMenus(nodemenus);
      DisplayBeep(NULL);
      LibFreePooled(mempool,Nodes_GroupNodes,26*sizeof(struct TempNode));
      return;
   }

   Nodes_UpdateList();
   Nodes_SetCurrent(0);
   Nodes_ChangedNum();

   for(;;)
   {
      while(IntuiMessage=(struct IntuiMessage *)LT_GetIMsg(parthandle))
      {
         class=IntuiMessage->Class;
         code=IntuiMessage->Code;
         iaddress=IntuiMessage->IAddress;
         qualifier=IntuiMessage->Qualifier;

         LT_ReplyIMsg(IntuiMessage);

         switch(class)
         {
            case IDCMP_RAWKEY:         if(code == RAWKEY_TAB) LT_Activate(parthandle,4000+LV_STRING);
                                       break;

            case IDCMP_IDCMPUPDATE:    if(Nodes_CurrentNode)
                                       {
                                          cnode=Nodes_CurrentNode->UserData;

                                          switch(((struct Gadget *)iaddress)->GadgetID)
                                          {
                                             case 20:
                                                if(CheckFlags('A'+Nodes_CurrentGroup,cnode->FullAccessGroups))
                                                   Nodes_SetGroup(2);

                                                else if(CheckFlags('A'+Nodes_CurrentGroup,cnode->ReadOnlyGroups))
                                                   Nodes_SetGroup(3);

                                                else if(CheckFlags('A'+Nodes_CurrentGroup,cnode->WriteOnlyGroups))
                                                   Nodes_SetGroup(0);

                                                else
                                                   Nodes_SetGroup(1);

                                                break;

                                             case 30:
                                                if(Nodes_CurrentAreaNode)
                                                {
                                                   area=Nodes_CurrentAreaNode->UserData;

                                                   if((ticknode=Nodes_FindTickNode(area,cnode)))
                                                   {
                                                      if(ticknode->Flags == TICKNODE_READONLY)
                                                         ticknode->Flags=TICKNODE_WRITEONLY;

                                                      else if(ticknode->Flags == TICKNODE_WRITEONLY)
                                                         ticknode->Flags=0;

                                                      else
                                                         ticknode->Flags=TICKNODE_READONLY;

                                                      LT_SetAttributes(parthandle,30,GTLV_Labels,~0,TAG_END);
                                                      Nodes_MakeArea(area,ticknode,Nodes_CurrentAreaNode);
                                                      LT_SetAttributes(parthandle,30,GTLV_Labels,&Nodes_TempAreaList,TAG_END);
                                                      Nodes_SetCurrentArea(Nodes_CurrentAreaNode->num);
                                                      config.configchanged=TRUE;
                                                   }
                                                }
                                                break;

                                              case 42:
                                                group=AskGroup(partwin,getString(PREFS_NO_GROUP));

                                                if(group != -1)
                                                {
                                                    cnode->DefaultGroup=group;
                                                    Nodes_UpdateConfig();  
                                                    Nodes_SetCurrent(Nodes_CurrentNode->num);
                                                    config.configchanged=TRUE;
                                                }
                                                break;
                                          }
                                       }
                                       break;

            case IDCMP_GADGETUP:       /* No current node necessary */

                                       switch(((struct Gadget *)iaddress)->GadgetID)
                                       {
                                          case 35:
                                             Nodes_Selectmode=code;
                                             break;

                                          case 100:
                                             Nodes_UpdateConfig();
                                             LT_SetAttributes(parthandle,99,LAGR_ActivePage,code,TAG_END);
                                             Nodes_Activepage=code;

                                             if(Nodes_CurrentNode)
                                                Nodes_SetCurrent(Nodes_CurrentNode->num);

                                             else
                                                Nodes_SetCurrent(0);

                                             break;

                                          case 4000+LV_ADD:
                                             Nodes_UpdateConfig();
                                             Nodes_Add();
                                             break;
                                       }

                                       /* Current node necessary */

                                       if(Nodes_CurrentNode)
                                       {
                                          cnode=Nodes_CurrentNode->UserData;

                                          switch(((struct Gadget *)iaddress)->GadgetID)
                                          {
                                             case 20:
                                                Nodes_SetCurrentGroup(code);
                                                break;

                                             case 21:
                                                Nodes_SetGroup(code);
                                                break;

                                             case 30:
                                                Nodes_SetCurrentArea(code);
                                                break;

                                             case 31:
                                                if(Nodes_CurrentAreaNode)
                                                {
                                                   area=Nodes_CurrentAreaNode->UserData;

                                                   if((ticknode=Nodes_FindTickNode(area,cnode)))
                                                   {
                                                      switch(code)
                                                      {
                                                         case 0:
                                                            ticknode->Flags=0;
                                                            break;

                                                         case 1:
                                                            ticknode->Flags=TICKNODE_READONLY;
                                                            break;

                                                         case 2:
                                                            ticknode->Flags=TICKNODE_WRITEONLY;
                                                            break;
                                                      }

                                                      LT_SetAttributes(parthandle,30,GTLV_Labels,~0,TAG_END);
                                                      Nodes_MakeArea(area,ticknode,Nodes_CurrentAreaNode);
                                                      LT_SetAttributes(parthandle,30,GTLV_Labels,&Nodes_TempAreaList,TAG_END);
                                                      config.configchanged=TRUE;
                                                   }
                                                }
                                                break;

                                             case 36:
                                                Nodes_AddArea();
                                                break;

                                             case 37:
                                                if(Nodes_CurrentAreaNode)
                                                {
                                                   tmp=Nodes_CurrentAreaNode->num;

                                                   if(!Nodes_CurrentAreaNode->Node.ln_Succ->ln_Succ)
                                                      tmp--;

                                                   area=Nodes_CurrentAreaNode->UserData;
                                                   ticknode=Nodes_FindTickNode(area,cnode);

                                                   if(ticknode)
                                                   {
                                                      LT_SetAttributes(parthandle,30,GTLV_Labels,~0,TAG_END);
                                                      jbFreeNode(&area->TickNodes,(struct jbNode *)ticknode,sizeof(struct TickNode));
                                                      Remove((struct Node *)Nodes_CurrentAreaNode);
                                                      Nodes_RenumberAreaList();
                                                      LibFreePooled(mempool,Nodes_CurrentAreaNode,sizeof(struct TempNode));
                                                      Nodes_SetCurrentArea(tmp);
                                                      Nodes_ChangedAreaNum();
                                                      LT_SetAttributes(parthandle,30,GTLV_Labels,&Nodes_TempAreaList,TAG_END);
                                                      config.configchanged=TRUE;
                                                   }
                                                }
                                                break;

                                             case 4000+LV_LIST:
                                                Nodes_UpdateConfig();
                                                Nodes_SetCurrent(code);
                                                break;

                                             case 4000+LV_STRING:
                                                if(!Parse4D(getgadgetstring((struct Gadget *)iaddress),&n4d))
                                                {
                                                   DisplayBeep(NULL);
                                                   LT_Activate(parthandle,4000+LV_STRING);
                                                }
                                                else
                                                {
                                                   if(CheckDupeNode(&n4d,cnode))
                                                   {
                                                      LV_DetachList(parthandle,4000);
                                                      PrintFull4D(&n4d,Nodes_CurrentNode->buf);
                                                      Copy4D(&cnode->Node,&n4d);
                                                      LV_AttachList(parthandle,4000,&Nodes_TempList);
                                                      config.configchanged=TRUE;
                                                   }
                                                   else
                                                   {
                                                      RequestError(partwin,getString(PREFS_NODES_ALREADY_HAS),
                                                         n4d.Zone,
                                                         n4d.Net,
                                                         n4d.Node,
                                                         n4d.Point);

                                                      LT_Activate(parthandle,4000+LV_STRING);
                                                   }
                                                }
                                                break;

                                             case 4000+LV_REMOVE:
                                                Nodes_Remove();
                                                break;

                                             case 4000+LV_UP:
                                                LV_MoveUp(parthandle,4000,&Nodes_TempList,Nodes_CurrentNode,&config.CNodeList);
                                                config.configchanged=TRUE;
                                                break;

                                             case 4000+LV_DOWN:
                                                LV_MoveDown(parthandle,4000,&Nodes_TempList,Nodes_CurrentNode,&config.CNodeList);
                                                config.configchanged=TRUE;
                                                break;
                                          }
                                      }
                                      break;

            case IDCMP_MENUPICK:      num=code;
                                      while(num!=MENUNULL)
                                      {
                                          if(Nodes_CurrentNode)
                                          {
                                             cnode=Nodes_CurrentNode->UserData;

                                             if(MENUNUM(num)==0 && ITEMNUM(num)==0)
                                             {
                                                Nodes_UpdateConfig();
                                                Nodes_Duplicate();
                                             }

                                             if(MENUNUM(num)==0 && ITEMNUM(num)==2)
                                             {
                                                Nodes_UpdateConfig();
                                                Nodes_AddMandatory();
                                             }

                                             menuitem=ItemAddress(nodemenus,num);
                                             num=menuitem->NextSelect;
                                          }
                                      }
                                      break;

            case IDCMP_CLOSEWINDOW:   Nodes_UpdateConfig();
                                      ClearMenuStrip(parthandle->Window);
                                      LT_DeleteHandle(parthandle);
                                      FreeMenus(nodemenus);
                                      parthandle=NULL;

                                      FreeTempNodes(&Nodes_TempList);
                                      FreeTempNodes(&Nodes_TempAreaList);
                                      LibFreePooled(mempool,Nodes_GroupNodes,26*sizeof(struct TempNode));
                                      return;

         }
      }
      WaitPort(partwin->UserPort);
   }
}

