#include <typedefs.h>
#include <mystdlib.h>
#include <jblist.h>

#include <exec/types.h>
#include <clib/alib_protos.h>

extern APTR mempool;

void jbNewList(struct jbList *list)
{
   list->First=NULL;
   list->Last=NULL;
}

void jbAddNode(struct jbList *list, struct jbNode *node)
{
   if(!list->First)
      list->First=node;

   else
      list->Last->Next=node;

   list->Last=node;
   node->Next=NULL;
}

void jbFreeList(struct jbList *list,ulong sizenode)
{
   struct jbNode *tmp,*tmp2;

   for(tmp=list->First;tmp;)
   {
      tmp2=tmp->Next;
      LibFreePooled(mempool,tmp,sizenode);
      tmp=tmp2;
   }

   list->First=NULL;
   list->Last=NULL;
}

void jbFreeNum(struct jbList *list,ulong num,ulong size)
{
   struct jbNode *old=NULL,*tmp;
   ulong c;

   tmp=list->First;

   for(c=0;c<num && tmp;c++)
   {
      if(c==num-1)
         old=tmp;

     tmp=tmp->Next;
   }

   if(c==num)
   {
      if(old)
         old->Next=tmp->Next;

      if(num==0)
         list->First=tmp->Next;

      if(tmp->Next == NULL)
         list->Last=old;

      LibFreePooled(mempool,tmp,size);
   }
}

void jbFreeNode(struct jbList *list,struct jbNode *node,ulong size)
{
   struct jbNode *old=NULL,*tmp;

   for(tmp=list->First;tmp;tmp=tmp->Next)
   {
      if(tmp->Next == node)
         old=tmp;

      if(tmp == node) break;
   }

   if(tmp == node)
   {
      if(old)
         old->Next=tmp->Next;

      if(node == list->First)
         list->First=tmp->Next;

      if(tmp->Next == NULL)
         list->Last=old;

      LibFreePooled(mempool,tmp,size);
   }
}

void jbInsertNode(struct jbList *list,struct jbNode *node,struct jbNode *newnode)
{
   /* Add this as the first node */

   if(node == NULL)
   {
      newnode->Next=list->First;

      if(list->Last == list->First)
         list->Last=newnode;

      list->First=newnode;
   }
   else
   {
      newnode->Next=node->Next;
      node->Next=newnode;

      if(list->Last == node)
         list->Last=newnode;
   }
}

