#ifndef __MYSTDLIB_H__
#define __MYSTDLIB_H__

#include <stdarg.h>

#include <dos/dos.h>
#include <shared/node4d.h>

struct jbFile
{
   BPTR fh;
   UBYTE *buf;
   ULONG bufsize;
   ULONG len;
   ULONG pos;
   UWORD mode;
};

struct jbFile *jbOpen(UBYTE *name,UWORD mode,ULONG bufsize);
void jbClose(struct jbFile *jb);
int jbGetChar(struct jbFile *jb);
ulong jbRead(struct jbFile *jb,void *buf,ULONG bytes);
void jbPutChar(struct jbFile *jb, UBYTE ch);
void jbWrite(struct jbFile *jb,const void *buf, ULONG bytes);
void jbPuts(struct jbFile *jb, UBYTE *str);
short jbFGets(struct jbFile *jb,UBYTE *str,ULONG max);
void jbFPrintf(struct jbFile *jb,uchar *fmt,...);
void jbVFPrintf(struct jbFile *jb,uchar *fmt,va_list args);

struct FileEntry
{
   struct FileEntry *Next;
   UBYTE Name[100];
   UBYTE Comment[80];
   struct DateStamp Date;
   ULONG Size;
};

short jbReadDir(uchar *dir,struct jbList *filelist,int (*acceptfunc)(uchar *filename));

void *AllocCleared(ulong size);

extern long jbcpos;
short jbstrcpy(char *dest,char *src,long maxlen);

ulong hextodec(UBYTE *hex);
short MoveFile(uchar *file,uchar *newfile);

void mystrncpy(uchar *dest,uchar *src,ulong len);

long jbGetSize(uchar *file);
short CopyFile(uchar *file,uchar *newfile);

#endif
