#include <typedefs.h>
#include <node4d.h>
#include <string.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* Routines for parsing and comparing node numbers in 2D and 4D */

int Parse4D(uchar *buf, struct Node4D *node)
{
   unsigned long c=0,val=0;
   int GotZone=FALSE,GotNet=FALSE,GotNode=FALSE;

   node->Zone=0;
   node->Net=0;
   node->Node=0;
   node->Point=0;

	for(c=0;c<strlen(buf);c++)
	{
		if(buf[c]==':')
		{
         if(GotZone || GotNet || GotNode) return(FALSE);
			node->Zone=val;
         GotZone=TRUE;
			val=0;
	   }
		else if(buf[c]=='/')
		{
         if(GotNet || GotNode) return(FALSE);
         node->Net=val;
         GotNet=TRUE;
			val=0;
		}
		else if(buf[c]=='.')
		{
         if(GotNode) return(FALSE);
         node->Node=val;
         GotNode=TRUE;
			val=0;
		}
		else if(buf[c]>='0' && buf[c]<='9')
		{
         val*=10;
         val+=buf[c]-'0';
		}
		else return(FALSE);
	}
   if(GotZone && !GotNet)  node->Net=val;
   else if(GotNode)        node->Point=val;
   else                    node->Node=val;

   return(TRUE);
}

int Compare4D(struct Node4D *node1,struct Node4D *node2)
{
   if(node1->Zone!=0 && node2->Zone!=0)
   {
      if(node1->Zone > node2->Zone) return(1);
      if(node1->Zone < node2->Zone) return(-1);
   }

   if(node1->Net  > node2->Net) return(1);
   if(node1->Net  < node2->Net) return(-1);

   if(node1->Node > node2->Node) return(1);
   if(node1->Node < node2->Node) return(-1);

   if(node1->Point > node2->Point) return(1);
   if(node1->Point < node2->Point) return(-1);

   return(0);
}

void Copy4D(struct Node4D *node1,struct Node4D *node2)
{
   memcpy(node1,node2,sizeof(struct Node4D));
}

void Print4D(struct Node4D *node,uchar *buf)
{
   if(node->Point == 0)
   {
      sprintf(buf,"%lu:%lu/%lu",
         node->Zone,node->Net,node->Node);
   }
   else
   {
      sprintf(buf,"%lu:%lu/%lu.%lu",
         node->Zone,node->Net,node->Node,node->Point);
   }
}

void PrintFull4D(struct Node4D *node,uchar *buf)
{
   sprintf(buf,"%lu:%lu/%lu.%lu",
      node->Zone,node->Net,node->Node,node->Point);
}
